Package: SubCellBarCode
Type: Package
Title: SubCellBarCode: Integrated workflow for robust mapping and
        visualizing whole human spatial proteome
Version: 1.27.0
Author: Taner Arslan
Maintainer: Taner Arslan <taner.arslan@ki.se>
Description: Mass-Spectrometry based spatial proteomics have enabled the proteome-wide mapping of protein subcellular localization (Orre et al. 2019, Molecular Cell). SubCellBarCode R package robustly classifies proteins into corresponding subcellular localization.
License: GPL-2
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.6)
Suggests: knitr, rmarkdown, BiocStyle
Imports: Rtsne, scatterplot3d, caret, e1071, ggplot2, gridExtra,
        networkD3, ggrepel, graphics, stats, org.Hs.eg.db,
        AnnotationDbi
biocViews: Proteomics, MassSpectrometry, Classification
RoxygenNote: 7.1.1
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/SubCellBarCode
git_branch: devel
git_last_commit: 945ded8
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-11-01 00:34:52 UTC; biocbuild

#' @title Evaluate the quality of the marker proteins
#' @description Given the proteomics data, quality of the overlapped
#' marker proteins are evaluated by correlating replicates of fractions.
#' @param coveredProteins character; list of marker proteins, gene
#' symbols, that are covered in 3365 marker proteins.
#' @param protein.data data.frame; fractionated proteomics data,
#' rownames are gene symbols associated protein.
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'r.markers <- markerQualityControl(c.prots[1:5], df)
#'}
#' @import ggplot2
#' @import gridExtra
#' @importFrom stats cor
#' @return robustMarkers


markerQualityControl <- function(coveredProteins, protein.data){

    # replicate-wise correlation marker QC
    m.prot.df <- protein.data[coveredProteins, ]
    m.prot.df <- m.prot.df[complete.cases(m.prot.df),]

    if( nrow(m.prot.df) < 1)
        stop('Make sure your inputs are correct. Type ?markerQualityControl')

    fracs.df.A <- m.prot.df[, grepl("\\.A\\.", colnames(m.prot.df))]
    fracs.df.B <- m.prot.df[, grepl("\\.B\\.", colnames(m.prot.df))]

    cor.reps.pearson <- vapply(rownames(fracs.df.A),
        function (x) {cor(unlist(fracs.df.A[x, ]), unlist(fracs.df.B[x, ]),
                            method="pearson")},
                            as.numeric(""))

    replicate.df <- data.frame(Protein = names(cor.reps.pearson),
                                Correlation = cor.reps.pearson)

    p1 <- ggplot(replicate.df, aes(x = Correlation)) +
        geom_density(alpha = .7, fill = "deepskyblue") +
        theme_minimal() +
        theme(text = element_text(size = 14),
                plot.title = element_text(hjust = 0.5, size = 14),
                axis.text.x = element_text(face = "bold", color="black"),
                axis.text.y = element_text(face = "bold", color="black")) +
        geom_vline(xintercept = 0.8, linetype="dashed", color = "red") +
        labs(title = "Replicate-Wise Correlation Marker QC",
                tag = "A",
                y = "Density",
                x = "Pearson Corr.")

    #remove replicate-wise markerp proteins
    rep.prots <- names(cor.reps.pearson[cor.reps.pearson < 0.8 ])

    message("Number of removed replicate-wise proteins: ", length(rep.prots))

    # sample-wise correlation marker QC
    prot.names <- setdiff(rownames(m.prot.df), rep.prots)
    markerProteins <- SubCellBarCode::markerProteins[prot.names,][,3:7]
    m.prot.df <- m.prot.df[prot.names,]

    # function for to calculate sample-wise correlation for each protein
    prot.cor <- function(df, marker.df, cor.method = c("spearman", "pearson")){
        unlist(lapply(rownames(m.prot.df), function(x){
            p.cor <- cor(t(df[x,]), t(marker.df[x,]), method = cor.method)
            names(p.cor) <- x
            p.cor
        }))}


    pearson.corA <- prot.cor(df = m.prot.df[grepl("\\.A\\.",
                                                colnames(m.prot.df))],
                                marker.df = markerProteins,
                                cor.method = "pearson")

    pearson.corB <- prot.cor(df = m.prot.df[grepl("\\.B\\.",
                                                colnames(m.prot.df))],
                                marker.df = markerProteins,
                                cor.method = "pearson")

    pearson.cor <- data.frame(RepA = pearson.corA, RepB = pearson.corB)
    pearson.cor$MinP.Cor <- apply(pearson.cor, 1, min)

    spear.corA <- prot.cor(df = m.prot.df[grepl("\\.A\\.",
                                            colnames(m.prot.df))],
                                marker.df = markerProteins,
                                cor.method = "spearman")

    spear.corB <- prot.cor(df = m.prot.df[grepl("\\.B\\.",
                                            colnames(m.prot.df))],
                                marker.df = markerProteins,
                                cor.method = "spearman")

    spear.cor <- data.frame(RepA = spear.corA, RepB = spear.corA)
    spear.cor$MinS.cor <- apply(spear.cor, 1, min)

    df <- data.frame(Protein = rownames(spear.cor),
                        Pearson = pearson.cor$MinP.Cor,
                        Spearman = spear.cor$MinS.cor)

    cols <- SubCellBarCode::markerProteins[prot.names,][8]
    Color <- cols$Colour

    p2 <- ggplot(df, aes(x = Pearson, y = Spearman)) +
        geom_point(colour = Color, size = 2) +
        geom_hline(yintercept = 0.6, linetype="dashed", color = "red") +
        geom_vline(xintercept = 0.8, linetype="dashed", color = "red") +
        labs(title = "Sample-Wise Correlation Marker QC",
            tag = "B",
            y = "Spearman Corr.",
            x = "Pearson Corr.") +
        theme_minimal() +
        theme(text = element_text(size = 14),
            plot.title = element_text(hjust = 0.5, color = "black", size = 14),
            axis.text.x = element_text(face = "bold", color="black"),
            axis.text.y = element_text(face = "bold", color="black"))

    sample.removed.prot <- df[df$Pearson < 0.8 | df$Spearman < 0.599,]
    sample.removed.prot <- as.character(sample.removed.prot$Protein)

    message("Number of removed sample-wise proteins: ",
            length(sample.removed.prot))

    robustMarkerProteins <- setdiff(prot.names, sample.removed.prot)

    message("Number of total removed marker proteins: ",
                    length(sample.removed.prot) + length(rep.prots))

    grid.arrange(p1, p2, ncol=2)

    # check if there is a depletion after marker qc
    compartment.size <- c(358, 351, 252, 174, 192, 121, 231, 198, 242,
                            132, 220, 215, 341, 69, 269)

    compartments <- c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4",
                        "C1", "C2", "C3", "C4", "C5", "M1", "M2")
    r.marker.df <- SubCellBarCode::markerProteins[robustMarkerProteins, ]

    coverageCompWise <- lapply(seq_len(length(compartments)), function(x){
        temp.df <- r.marker.df[r.marker.df$Compartments == compartments[x], ]
        values <- list(Compartments = compartments[x],
            ProteinCoverage = 100 * ((dim(temp.df)[1]) /compartment.size[x]))
    })

    r.cov.df <- as.data.frame(do.call("rbind", coverageCompWise))

    non.enriched.loc <- r.cov.df[r.cov.df$ProteinCoverage < 20, ]
    if(nrow(non.enriched.loc) == 1){
        warning("There is not enough enrichment at: ",
                as.character(non.enriched.loc$Compartments),
                "\nWe recommend you to perform the fractionation, again.")
    }else if(nrow(non.enriched.loc) > 1){
        comp <- paste(as.character(non.enriched.loc$Compartments),
                    collapse = ",")
        warning("There are not enough enrichments at: ",
                comp, "\nWe recommend you to perform the fractionation.")
    }

    return(robustMarkerProteins)
}

#'@title Compute the means of replicates
#'@description Duplicated franctions A and B are
#'summarized by taking their mean for each protein.
#'After taking the mean, the data log2 transformed.
#'Further, the 5 main fractions are used to check correlation
#'between input datas. It is a helper function.
#'@param d.df data.frame; A data frame of 10 fraction profiles
#' consisting of replicate A and B.
#'@export
#'@examples {
#'
#'r.df <- calRowMean(SubCellBarCode::hcc827Ctrl)
#'
#'}
#'@return r.df

calRowMean <- function(d.df){
    r.means <- lapply(seq_len(5), function(x){
        k <- 2 * x -1
        t.df <- rowMeans(d.df[, c(k:(k+1))])
    })

    r.df <- data.frame(do.call("cbind", r.means))
    colnames(r.df) <- c("Cyto", "Nsol", "NucI", "Horg", "Lorg")
    r.df <- log2(r.df)
    return(r.df)
}

#'@title Sankey plot for condition-dependent protein relocalization
#'@description Identify candidate condition-dependent relocated
#'proteins by comparing neighborhood classifications.
#'@param sampleCls1 data.frame; merged classification,
#'combination of compartment and neighborhood classification.
#'@param sampleCls2 data.frame; merged classification,
#'combination of compartment and neighborhood classification.
#'@export
#'@examples {
#'
#'exp.cls.df <- SubCellBarCode::hcc827GEFClass
#'
#'sankeyData <- sankeyPlot(exp.cls.df, exp.cls.df)
#'
#'}
#'@import networkD3
#'@return label.link.df


sankeyPlot <- function(sampleCls1, sampleCls2){

    # just keep neighborhood classification
    df1 <- sampleCls1[, seq_len(2)]
    df2 <- sampleCls2[, seq_len(2)]

    df1 <- df1[intersect(rownames(df1), rownames(df2)), ]
    df2 <- df2[intersect(rownames(df1), rownames(df2)), ]

    df2 <- df2[rownames(df1), ]

    df <- data.frame(Protein = df1$Protein,
                        C.A = df1$NeighborhoodCls,
                        C.B = df2$NeighborhoodCls)

    #remove unclassfied proteins at both conditions
    f.df <- df[!grepl("Unclassified",df$C.A) & ! grepl("Unclassified",df$C.B),]

    neighborhoods <- c("Secretory", "Nuclear", "Cytosol", "Mitochondria")
    label.neigh <- c(0, 1, 2, 3)

    neighborhoods2 <- c("Secretory", "Nuclear", "Cytosol", "Mitochondria")
    label.neigh2 <- c(4, 5, 6, 7)

    # summarize using neighborhoods labels
    sourceTarget <- lapply(neighborhoods, function(n1){
        temp.n1.df <- df[df$C.A == n1, ]

        results <- lapply(neighborhoods2, function(n2){
            temp.n2.df <- temp.n1.df[temp.n1.df$C.B == n2, ]
            values <- list(Cond1 = n1,
                            Cond2 = n2,
                            value = nrow(temp.n2.df))
        })
        result.df <- data.frame(do.call(rbind.data.frame, results))
    })

    label.link.df <- link.df <- do.call("rbind", sourceTarget)
    rownames(label.link.df) <- seq_len(nrow(label.link.df))
    print(label.link.df)

    # summarize neighborhood to neighborhood localization
    sourceTarget <- lapply(seq_len(4), function(n1){
        temp.n1.df <- df[df$C.A == neighborhoods[n1], ]

        results <- lapply(seq_len(4), function(n2){
                temp.n2.df <- temp.n1.df[temp.n1.df$C.B == neighborhoods2[n2], ]
                values <- list(source = label.neigh[n1],
                                target = label.neigh2[n2],
                                value = nrow(temp.n2.df))
        })
        result.df <- data.frame(do.call(rbind.data.frame, results))
    })

    # source to link for the sankey plot
    link.df <- do.call("rbind", sourceTarget)
    link.df <- link.df[link.df$value > 0, ]
    rownames(link.df) <- seq_len(nrow(link.df))

    # prepare nodes dataframe
    neigh.names <- c("Cond1.Secretory", "Cond1.Nuclear", "Cond1.Cytosol",
                        "Cond1.Mitochondria", "Cond2.Secretory",
                        "Cond2.Nuclear", "Cond2.Cytosol", "Cond2.Mitochondria")

    group <- as.character(c(1, 2, 3, 4, 1, 2, 3, 4))

    id <- c(0, 1, 2, 3, 4, 5, 6, 7)

    sankeyNodes <- data.frame(neigh.names, id, group)

    sankeyData <- list(sankeyNodes, link.df)

    # plot sankey plot
    networkD3::sankeyNetwork(Links = link.df,
                                Nodes = sankeyNodes,
                                Source = "source",
                                Target = "target",
                                Value = "value",
                                NodeID = "neigh.names",
                                fontSize = 12,
                                nodeWidth = 30,
                                colourScale = JS(
                                    'd3.scaleOrdinal()
                                    .domain(["0", "1", "2", "3", "4",
                                            "5", "6", "7"])
                                    .range(["#FFC125", "#CCCCCC",
                                            "#98F5FF", "#CD853F"])'))

}

#'@title Convert identifier to gene symbol
#'@description Identifier for each feature should be converted
#'into gene symbols unless they are not gene symbols
#'@param df data.frame; fractionated proteomics data where
#'data contains 10 columns of duplicated 5 fractionations and
#'rownames must be identifier e.g. UNIPROT, Entrez ID
#'@param id caharacter; identifier id for each protein
#'@import org.Hs.eg.db
#'@import AnnotationDbi
#'@export
#'@examples {
#'
#'df <- data.frame(Uniprot = c("A4D0S4","A8TX70","O00305","O00337"),
#'Organism = rep("Homo Sap.", 4))
#'
#'rownames(df) <- df$Uniprot
#'}
#'
#'@return df
#'


convert2symbol <- function(df, id = "UNIPROT"){

    if (! id %in% columns(org.Hs.eg.db))
        stop('Enter valid identifier.')

    if (! is.character(rownames(df)))
        stop('Rownames must be character!')

    uniprot.id <- as.character(unique(rownames(df)))

    #converting ids
    annot.df<- AnnotationDbi::select(org.Hs.eg.db,
                            keys = uniprot.id,
                            keytype = id,
                            columns = "SYMBOL")

    ## filter-1 ids
    #filter if there is no corresponding symbol
    annot.df <- annot.df[complete.cases(annot.df),]

    #filter if there multiple id corresponding one one symbol
    #remove one of them
    annot.df <- annot.df[!duplicated(annot.df$SYMBOL),]

    #filter-3 if one id matches to multiple symbol
    dup.ids <- annot.df$UNIPROT[duplicated(annot.df$UNIPROT)]
    annot.df <- subset(annot.df, ! annot.df$UNIPROT %in% dup.ids)

    df <- df[as.character(annot.df$UNIPROT),]
    rownames(df) <- annot.df$SYMBOL

    return(df)
}

#'@title Probability threshold for compartment classification
#'@description Thresholds for each compartment are decided to get
#'confident predictions.
#'@param test.repA data.frame; test predictions, observation and
#'probablity vectors for each protein in replicate A
#'@param test.repB data.frame; test predictions, observation and
#'probablity vectors for each protein in replicate B
#'@importFrom stats aggregate
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 550)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'
#'test.A <- cls[[1]]$svm.test.prob.out
#'test.B <- cls[[2]]$svm.test.prob.out
#'
#'t.c.df <- computeThresholdCompartment(test.A, test.B)
#'}
#'@return threshold.compartment.df

computeThresholdCompartment <- function(test.repA, test.repB){

    if( ! identical(rownames(test.repA), rownames(test.repB)) )
        stop('Replicates have to posses same indexed rownames')

    #merge two replicates and average them
    test.repA.match <- test.repA[test.repA$svm.pred == test.repB$svm.pred, ]
    test.repA.match$Proteins <- rownames(test.repA.match)
    test.repB.match <- test.repB[test.repA$svm.pred == test.repB$svm.pred, ]
    test.repB.match$Proteins <- rownames(test.repB.match)

    combined.reps <- rbind(test.repA.match, test.repB.match)
    combined.df <- data.frame(Proteins = combined.reps$Proteins,
                                combined.reps[, 3:17])
    averaged.reps <- aggregate(.~Proteins, data = combined.df, mean)
    rownames(averaged.reps) <- averaged.reps$Proteins
    averaged.reps <- averaged.reps[rownames(test.repA.match),]

    combined.rep.A.B <- data.frame(Proteins = averaged.reps$Proteins,
                                    Observation = test.repA.match$Observation,
                                    svm.pred = test.repA.match$svm.pred,
                                    averaged.reps[, 2:16])


    #estimate the compartments theresholds  by calculating precision and recall
    cls.levels <- c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4",
                        "C1", "C2", "C3", "C4", "C5", "M1", "M2")

    results <- lapply(cls.levels,function(l){
        cls.df <- combined.rep.A.B[combined.rep.A.B$svm.pred==l, ]
        cls.obs.df <- test.repA[test.repA$Observation==l, ]
        if(nrow(cls.df) > 0 & nrow(cls.obs.df) > 0){
            parameters <- lapply(seq(0, 1, 0.005), function(t){
            u.df <- cls.df[cls.df[l] >= t, ]
            p.cls <- sum(u.df$Observation == u.df$svm.pred) / nrow(u.df)
            cls.down.df <- cls.df[cls.df[l] < t, ]
            r.cls <- (sum(u.df$Observation == u.df$svm.pred)) / nrow(cls.obs.df)
            f.score <- (2 * p.cls * r.cls) / (p.cls + r.cls)
            values <- list(Precision = p.cls,
                            Recall = r.cls,
                            fscore = f.score,
                            threshold = t,
                            Compartment = l)
            })

            result.df <- data.frame(do.call(rbind.data.frame, parameters))
            up.precision <- result.df[result.df$Precision>= 0.9, ]
            recall.threshold <- result.df[!duplicated(result.df[,c('Recall')]),]
            threshold.df <- list(Compartment = l,
                                Precision = up.precision$threshold[1],
                                Recall = recall.threshold$threshold[2])
        }})

    threshold.compartment.df <- data.frame(do.call(rbind, results))

    missing.comp <- setdiff(cls.levels, threshold.compartment.df$Compartment)

    if(length(missing.comp) > 1){
        miss.df <- data.frame(Compartment = missing.comp,
                            Precision = rep("NA", length(missing.comp)),
                            Recall = rep("NA", length(missing.comp)))
        threshold.compartment.df <- rbind(threshold.compartment.df, miss.df)
        comps <- threshold.compartment.df$Compartment
        rownames(threshold.compartment.df) <- comps
        threshold.compartment.df <- threshold.compartment.df[cls.levels,]

    }else if(length(missing.comp) == 1){
        miss.df <- data.frame(Compartment = missing.comp,
                            Precision = "NA",
                            Recall = "NA")
        threshold.compartment.df <- rbind(threshold.compartment.df, miss.df)
        comps <- threshold.compartment.df$Compartment
        rownames(threshold.compartment.df) <- comps
        threshold.compartment.df <- threshold.compartment.df[cls.levels,]
    }else{
        threshold.compartment.df <- threshold.compartment.df
    }
    colnames(threshold.compartment.df)[2:3] <- c("PrecisionBasedThreshold",
                                                    "RecallBasedThreshold")
    threshold.compartment.df$OptedThreshold <- apply(threshold.compartment.df,
                                1, function(x) max(unlist(x[2]), unlist(x[3])))

    return(threshold.compartment.df)
}

## ----install,eval = FALSE-----------------------------------------------------
# if (!requireNamespace("BiocManager"))
#     install.packages("BiocManager")
# BiocManager::install("SubCellBarCode")

## ----Loadpackage--------------------------------------------------------------
library(SubCellBarCode)

## ----exampleData--------------------------------------------------------------
head(hcc827Ctrl)

## ----markerdata---------------------------------------------------------------
head(markerProteins)

## ----loadData-----------------------------------------------------------------
df <- loadData(protein.data = hcc827Ctrl)

## ----printDimData-------------------------------------------------------------
cat(dim(df))
head(df)

## ----convertID----------------------------------------------------------------
##Run if you have another identifier than gene symbols.
##Function will convert UNIPROT identifier to gene symbols.
##Deafult id is "UNIPROT", make sure you change it if you use another.

#df <- convert2symbol(df = df, id = "UNIPROT")

## ----subset data--------------------------------------------------------------
set.seed(2)
df <- df[sample(nrow(df), 6000),]

## ----coverageMarkers, fig = TRUE----------------------------------------------
c.prots <- calculateCoveredProtein(proteinIDs = rownames(df), 
                        markerproteins = markerProteins[,1]) 

## ----markerQC-----------------------------------------------------------------
r.markers <- markerQualityControl(coveredProteins = c.prots,protein.data = df)
r.markers[1:5]

## ----finalCoverage, fig = TRUE------------------------------------------------
## uncomment the function when running 
# f.prots <- calculateCoveredProtein(r.markers, markerProteins[,1])

## ----tsneparameter------------------------------------------------------------
#Default parameters
#Run the broad-range parameters to optimize well !!!
#Output dimensionality
#dims = 3
#Speed/accuracy trade-off (increase for less accuracy) 
#theta = c(0.1, 0.2, 0.3, 0.4, 0.5)
#Perplexity parameter
#perplexity = c(5, 10, 20, 30, 40, 50, 60) 

## ----tsnedim3, fig = TRUE, fig.width = 6.5, fig.height = 6.5------------------
set.seed(6)
tsne.map <- tsneVisualization(protein.data = df, 
                    markerProteins = r.markers, 
                    dims = 3, 
                    theta = c(0.1), 
                    perplexity = c(60)) 

## ----tsnedim2, fig = TRUE-----------------------------------------------------
set.seed(9)
tsne.map2 <- tsneVisualization(protein.data = df, 
                    markerProteins = r.markers, 
                    dims = 2, 
                    theta = c(0.5), 
                    perplexity = c(60))

## ----buildSVM-----------------------------------------------------------------
set.seed(4)
cls <- svmClassification(markerProteins = r.markers, 
                                    protein.data = df, 
                                    markerprot.df = markerProteins)

## ----testdata-----------------------------------------------------------------
# testing data predictions for replicate A and B
test.A <- cls[[1]]$svm.test.prob.out
test.B <- cls[[2]]$svm.test.prob.out
head(test.A)

## ----allPred------------------------------------------------------------------
# all predictions for replicate A and B
all.A <- cls[[1]]$all.prot.pred
all.B <- cls[[2]]$all.prot.pred

## ----compartmentThreshold-----------------------------------------------------
t.c.df <- computeThresholdCompartment(test.repA = test.A, test.repB = test.B)

## ----headcompartmentThreshold-------------------------------------------------
head(t.c.df)

## ----applycompartmentThreshold------------------------------------------------
c.cls.df <- applyThresholdCompartment(all.repA = all.A, all.repB = all.B,
                                    threshold.df = t.c.df)

## ----headcompartmentCls-------------------------------------------------------
head(c.cls.df)

## ----neighborhoodThreshold----------------------------------------------------
t.n.df <- computeThresholdNeighborhood(test.repA = test.A, test.repB = test.B)

## ----headneighborhoodThreshold------------------------------------------------
head(t.n.df)

## ----applyNeighborhoodThreshold-----------------------------------------------
n.cls.df <- applyThresholdNeighborhood(all.repA = all.A, all.repB = all.B, 
                                    threshold.df = t.n.df)

## ----headNeighborhoodCls------------------------------------------------------
head(n.cls.df)

## ----mergecls-----------------------------------------------------------------
cls.df <- mergeCls(compartmentCls = c.cls.df, neighborhoodCls = n.cls.df)

## ----headmerge----------------------------------------------------------------
head(cls.df)

## ----hcc827psmcount-----------------------------------------------------------
head(hcc827CtrlPSMCount)

## ----plotbarcode, fig = TRUE, fig.width = 6, fig.height = 6-------------------
plotBarcode(sampleClassification = cls.df, protein = "NLRP4",
        s1PSM = hcc827CtrlPSMCount)

## ----multipleprots, fig = TRUE, fig.width= 10, fig.height = 8-----------------
# 26S proteasome complex (26s proteasome regulatory complex)
proteasome26s <- c("PSMA7", "PSMC3","PSMA4", "PSMB4", 
                    "PSMB6", "PSMB5", "PSMC2","PSMC4",
                    "PSMB3", "PSMA6","PSMC5","PSMC6")

plotMultipleProtein(sampleClassification = cls.df, proteinList = proteasome26s)

## ----headHCC827GEFCls---------------------------------------------------------
head(hcc827GEFClass)

## ----sankey, fig.width = 6, fig.height = 3------------------------------------
sankeyPlot(sampleCls1 = cls.df, sampleCls2 = hcc827GEFClass)

## ----headPSMCount-------------------------------------------------------------
head(hcc827CtrlPSMCount)

## ----relocation parameters----------------------------------------------------
##parameters
#sampleCls1 = sample 1 classification output
#s1PSM = sample 2 PSM count
#s1Quant = Sample 1 Quantification data
#sampleCls2 = sample 2 classification output
#s2PSM = sample 2 classification output
#sample2Quant = Sample 2 Quantification data
#min.psm = minumum psm count
#pearson.cor = perason correlation coefficient

## ----strongCandidates, fig = TRUE---------------------------------------------
candidate.df <- candidateRelocatedProteins(sampleCls1 = cls.df, 
                                s1PSM = hcc827CtrlPSMCount, 
                                s1Quant = hcc827Ctrl,
                                sampleCls2 = hcc827GEFClass,
                                s2PSM = hcc827GefPSMCount,
                                s2Quant = hcc827GEF,
                                min.psm = 2,
                                pearson.cor = 0.8)

## ----printdim-----------------------------------------------------------------
cat(dim(candidate.df))

## ----printhead----------------------------------------------------------------
head(candidate.df)

## ----strongCandidatesLabel, fig = TRUE----------------------------------------
candidate2.df <- candidateRelocatedProteins(sampleCls1 = cls.df,
                                s1PSM = hcc827CtrlPSMCount, 
                                s1Quant = hcc827Ctrl, 
                                sampleCls2 = hcc827GEFClass, 
                                s2PSM = hcc827GefPSMCount, 
                                s2Quant = hcc827GEF, 
                                annotation = TRUE, 
                                min.psm = 9, 
                                pearson.cor = 0.05) 

## ----head exon data-----------------------------------------------------------
head(hcc827exon)

## ----recall model-------------------------------------------------------------
##recall the models
modelA <- cls[[1]]$model
modelB <- cls[[2]]$model

## ----exon centric cls---------------------------------------------------------
exon.cls <- svmExternalData(df = hcc827exon, modelA = modelA, modelB= modelB)

## ----exon cls-----------------------------------------------------------------
exon.A <- exon.cls[[1]]
exon.B <- exon.cls[[2]]

## ----exon cls rep A-----------------------------------------------------------
head(exon.A)

## ----apply thresholds---------------------------------------------------------
exon.comp.cls <- applyThresholdCompartment(all.repA = exon.A[,2:17], 
                                    all.repB = exon.B[,2:17],
                                    threshold.df = t.c.df)

exon.neigh.cls <- applyThresholdNeighborhood(all.repA = exon.A[,2:17], 
                                    all.repB = exon.B[,2:17], 
                                    threshold.df = t.n.df)

exon.cls.df <- mergeCls(compartmentCls = exon.comp.cls, 
                        neighborhoodCls = exon.neigh.cls)

#same order
exon.cls.df <- exon.cls.df[rownames(exon.A),]

# we will add gene symbols as well as peptide count  
# (PSM count is also accepted) in case for comparing with 
# gene-centric classifications

exon.cls.df$GeneSymbol <- exon.A$Gene_Symbol
exon.cls.df$PeptideCount <- hcc827exon$PeptideCount

## ----head exon cls------------------------------------------------------------
head(exon.cls.df)

## ----compareCls---------------------------------------------------------------
comp.df <- compareCls(geneCls = cls.df, exonCls = exon.cls.df)

## ----head comp.df-------------------------------------------------------------
head(comp.df)

## -----------------------------------------------------------------------------
sessionInfo()

#' @title Gefitinib treated HCC827 Cell Line Classification
#' @description Gefitinib treated HCC827 cell line classification
#' contains both neighborhood and compartment level. The data will be
#' used for the relocalization analysis.
#' @name hcc827GEFClass
#' @docType data
#' @usage hcc827GEFClass
#' @format A data frame where 10398 protein gene-centric ids and corresponding
#'compartment and neighborhood classification alon with
#'classification probabilities.
#'@keywords datasets
#'@examples {
#'head(hcc827GEFClass)
#'}
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#'@title Apply thresholds to compartments
#'@description Apply thresholds for all predictions to increase the
#'true positive rate and remove poor classification.
#'@param all.repA data.frame; all predictions and probablity vectors
#'for each protein in replicate A
#'@param all.repB data.frame; all predictions and probablity vectors
#'for each protein in replicate B
#'@param threshold.df data.frame; collection od precision and recall
#'values for each compaartment
#'@importFrom stats aggregate
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 550)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'
#'test.A <- cls[[1]]$svm.test.prob.out
#'test.B <- cls[[2]]$svm.test.prob.out
#'
#'t.c.df <- computeThresholdCompartment(test.A, test.B)
#'
#'all.A <- cls[[1]]$all.prot.pred
#'all.B <- cls[[2]]$all.prot.pred
#'
#'c.cls.df <- applyThresholdCompartment(all.A, all.B, t.c.df)
#'}
#'@return c.cls.df

applyThresholdCompartment <- function(all.repA, all.repB, threshold.df){

    if( ! identical(rownames(all.repA), rownames(all.repB)) )
        stop('Replicates have to posses same indexed rownames')

    all.repA$Proteins <- rownames(all.repA)
    all.repB$Proteins <- rownames(all.repB)

    #merge the replicates by averaging the probabilities
    repAB.mean <- rbind(all.repA, all.repB)[,-1]
    repAB.mean <- aggregate(.~Proteins, data = repAB.mean, mean)
    repAB <- data.frame(Proteins = repAB.mean$Proteins,
                        svm.pred = rep("Unclassified", nrow(repAB.mean)),
                        repAB.mean[,seq_len(16)])
    rownames(repAB) <- repAB$Proteins
    repAB <- repAB[rownames(all.repA), ]

    all.repA.match <- all.repA[all.repA$svm.pred.all == all.repB$svm.pred.all, ]
    all.repB.match <- all.repB[all.repB$svm.pred.all == all.repA$svm.pred.all, ]
    combined.repAB <- rbind(all.repA.match, all.repB.match)
    combined.df <- data.frame(Proteins = combined.repAB$Proteins,
                                combined.repAB[, 2:16])
    averaged.reps <- aggregate(.~Proteins, data = combined.df, mean)
    rownames(averaged.reps) <- averaged.reps$Proteins
    averaged.reps <- averaged.reps[rownames(all.repA.match), ]
    averaged.repAB <- data.frame(Proteins = averaged.reps$Proteins,
                                svm.pred = all.repA.match$svm.pred.all,
                                averaged.reps[, 2:16])


    #apply the theresholds for each compartment
    compartments <- c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4",
                        "C1", "C2", "C3", "C4", "C5", "M1", "M2")

    confident.classification <- lapply(compartments, function(m){
        #temp precision
        t.p <- unname(unlist(threshold.df[threshold.df$Compartment == m, ][2]))
        #temp recall
        t.r <- unname(unlist(threshold.df[threshold.df$Compartment == m, ][3]))
        t.value <- max(t.p, t.r)
        if(is.numeric(t.value)){
            temp.df <- averaged.repAB[averaged.repAB$svm.pred == m, ]
            up.threshold.df <- temp.df[temp.df[m] >= t.value, ]
        }
    })

    confident.df <- do.call("rbind", confident.classification)
    confident.df <- confident.df <- confident.df[complete.cases(confident.df),]

    # adding "unclassified proteins"
    no.clss <- subset(repAB, ! rownames(repAB) %in% rownames(confident.df))[-3]

    c.cls.df <- rbind(confident.df, no.clss)

}

#'@title Probability threshold for neighborhood classification
#'@description Thresholds for each neighborhood are decided to get
#' confident predictions.
#'@param test.repA data.frame; test predictions, observation and
#'probablity vectors for each protein in replicate A
#'@param test.repB data.frame; test predictions, observation and
#'probablity vectors for each protein in replicate B
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 600)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'
#'test.A <- cls[[1]]$svm.test.prob.out
#'test.B <- cls[[2]]$svm.test.prob.out
#'
#'t.n.df <- computeThresholdNeighborhood(test.A, test.B)
#'}
#'@return threshold.neighborhood.df

computeThresholdNeighborhood <- function(test.repA, test.repB){

    #upgrade compartment labels to neighborhood labels for prediction
    replaceObervation <- SubCellBarCode::replacePrediction(df = test.repA,
                                                    column = "Observation")
    neighborhood.repA <- SubCellBarCode::replacePrediction(df=replaceObervation,
                                                        column = "svm.pred")

    replaceObervation <- SubCellBarCode::replacePrediction(df = test.repB,
                                                    column = "Observation")
    neighborhood.repB <- SubCellBarCode::replacePrediction(df=replaceObervation,
                                                    column = "svm.pred")

    # concatanate the probabilities for corresponding neighborhood

    sum.repA <- SubCellBarCode::sumProbability(neighborhood.repA)
    sum.repB <- SubCellBarCode::sumProbability(neighborhood.repB)

    sum.repB <- sum.repB[rownames(sum.repA), ]

    #merge two replicates and average them
    n.test.repA.match <- sum.repA[sum.repA$svm.pred == sum.repB$svm.pred, ]
    n.test.repA.match$Proteins <- rownames(n.test.repA.match)
    n.test.repB.match <- sum.repB[sum.repB$svm.pred == sum.repA$svm.pred, ]
    n.test.repB.match$Proteins <- rownames(n.test.repB.match)

    combined.reps <- rbind(n.test.repA.match, n.test.repB.match)
    combined.df <- data.frame(Proteins = combined.reps$Proteins,
                                combined.reps[, 4:7])
    averaged.reps <- aggregate(.~Proteins, data = combined.df, mean)
    rownames(averaged.reps) <- averaged.reps$Proteins
    averaged.reps <- averaged.reps[rownames(n.test.repA.match), ]

    combined.rep.A.B <- data.frame(Proteins = averaged.reps$Proteins,
                                    Observation = n.test.repA.match$Observation,
                                    svm.pred = n.test.repA.match$svm.pred,
                                    averaged.reps[, 2:5])

    #estimate the neihborhood theresholds by calculating precision and recall
    cls.levels <- c("Secretory", "Nuclear", "Cytosol", "Mitochondria")

    results <- lapply(cls.levels, function(l){
        cls.df <- combined.rep.A.B[combined.rep.A.B$svm.pred == l, ]
        cls.obs.df <- neighborhood.repA[neighborhood.repA$Observation == l, ]
        parameters <- lapply(seq(0, 1, 0.005), function(t){
            u.df <- cls.df[cls.df[l] >= t, ]
            p.cls <- sum(u.df$Observation == u.df$svm.pred)/nrow(u.df)
            cls.down.df <- cls.df[cls.df[l] < t,]
            r.cls <- (sum(u.df$Observation == u.df$svm.pred))/nrow(cls.obs.df)
            f.score <- (2 * p.cls * r.cls) / (p.cls + r.cls)
            values <- list(Precision = p.cls,
                            Recall = r.cls,
                            fscore= f.score,
                            threshold = t,
                            Compartment = l)

        })
        result.df <- data.frame(do.call(rbind.data.frame, parameters))
        up.precision <- result.df[result.df$Precision >= 0.95, ]
        recall.threshold <- result.df[!duplicated(result.df[, c('Recall')]), ]
        threshold.df <- list(Neighborhood = l,
                                Precision = up.precision$threshold[1],
                                Recall = recall.threshold$threshold[2])
    })

    threshold.neighborhood.df <- data.frame(do.call(rbind, results))

    colnames(threshold.neighborhood.df)[2:3] <- c("PrecisionBasedThreshold",
                                                    "RecallBasedThreshold")
    threshold.neighborhood.df$OptedThreshold <- apply(threshold.neighborhood.df,
                                1, function(x) max(unlist(x[2]), unlist(x[3])))
    return(threshold.neighborhood.df)


}

#'@title Apply thresholds to neighborhood classification
#'@description Apply thresholds for all predictions at the
#'neighborhood level to increase the
#'true positive rate and remove poor classification.
#'@param all.repA data.frame; all predictions and probablity vectors
#'for each protein in replicate A
#'@param all.repB data.frame; all predictions and probablity vectors
#'for each protein in replicate B
#'@param threshold.df data.frame; collection od precision and recall
#'values for each neighborhood
#'@importFrom stats aggregate
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 600)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'
#'test.A <- cls[[1]]$svm.test.prob.out
#'test.B <- cls[[2]]$svm.test.prob.out
#'
#'t.n.df <- computeThresholdNeighborhood(test.A, test.B)
#'
#'all.A <- cls[[1]]$all.prot.pred
#'all.B <- cls[[2]]$all.prot.pred
#'
#'n.cls.df <- applyThresholdNeighborhood(all.A, all.B, t.n.df)
#'}
#'@return n.cls.df

applyThresholdNeighborhood <- function(all.repA, all.repB, threshold.df){

    #upgrade compartment labels to neighborhood labels for prediction
    all.n.repA <- SubCellBarCode::replacePrediction(df = all.repA,
                                            column = "svm.pred.all")
    all.n.repB <- SubCellBarCode::replacePrediction(df = all.repB,
                                            column = "svm.pred.all")

    #sum up compartment level predictions to neighborhood predictions
    m.all.repA <- SubCellBarCode::mergeProbability(all.n.repA)
    m.all.repB <- SubCellBarCode::mergeProbability(all.n.repB)

    m.all.repB <- m.all.repB[rownames(m.all.repA), ]

    #merge the replicates by averaging the probabilities
    all.repAB.mean <- rbind(m.all.repA, m.all.repB)[,-2]
    all.repAB.mean <- aggregate(.~Proteins, data = all.repAB.mean, mean)
    all.repAB <- data.frame(Proteins = all.repAB.mean$Proteins,
                    svm.pred.all = rep("Unclassified", nrow(all.repAB.mean)),
                    all.repAB.mean[,2:5])
    rownames(all.repAB) <- all.repAB$Proteins
    all.repAB <- all.repAB[rownames(m.all.repA), ]

    #merge two replicates and average them
    n.repA.m <- m.all.repA[m.all.repA$svm.pred.all == m.all.repB$svm.pred.all, ]
    n.repB.m <- m.all.repB[m.all.repB$svm.pred.all == m.all.repB$svm.pred.all, ]

    combined.reps <- rbind(n.repA.m, n.repB.m)
    combined.df <- data.frame(Proteins = combined.reps$Proteins,
                                combined.reps[, 3:6])
    averaged.reps <- aggregate(.~Proteins, data = combined.df, mean)
    rownames(averaged.reps) <- averaged.reps$Proteins
    averaged.reps <- averaged.reps[rownames(n.repA.m), ]

    combined.rep.A.B <- data.frame(Proteins = averaged.reps$Proteins,
                                    svm.pred.all = n.repA.m$svm.pred.all,
                                    averaged.reps[, 2:5])

    #apply the theresholds for each neighborhood
    neighborhoods <- c("Secretory","Nuclear", "Cytosol", "Mitochondria")

    confident.classification <- lapply(neighborhoods, function(m){
        # temp precision
        t.p <- unname(unlist(threshold.df[threshold.df$Neighborhood == m, ][2]))
        #temp recall
        t.r <- unname(unlist(threshold.df[threshold.df$Neighborhood == m, ][3]))
        t.value <- max(t.p, t.r)
        if (is.numeric(t.p)){
            temp.df <- combined.rep.A.B[combined.rep.A.B$svm.pred.all == m, ]
            up.threshold.df <- temp.df[temp.df[m] >= t.value, ]
        }
    })

    conf.df <- do.call("rbind", confident.classification)

    ##adding "unclassified proteins"
    no.class <- subset(all.repAB, ! rownames(all.repAB) %in% rownames(conf.df))

    n.cls.df <- rbind(conf.df, no.class)

}

#'@title Merge compartment probabilities to neighborhood probabilities
#'@description Compartment levels classifications are summed up to
#'associated neighborhood levels. It is a helper function.
#'@param df data.frame; all predictions at the neighborhood level and
#'probablity vectors for each protein
#'@export
#'@examples {
#'
#'#create mock data
#'df <- data.frame(Protein = "TP53",
#'S1 = as.numeric(0.02),
#'S2 = as.numeric(0.02),
#'S3 = as.numeric(0.02),
#'S4 = as.numeric(0.02),
#'N1 = as.numeric(0.72),
#'N2 = as.numeric(0.02),
#'N3 = as.numeric(0.02),
#'N4 = as.numeric(0.02),
#'C1 = as.numeric(0.02),
#'C2 = as.numeric(0.02),
#'C3 = as.numeric(0.02),
#'C4 = as.numeric(0.02),
#'C5 = as.numeric(0.02),
#'M1 = as.numeric(0.02),
#'M2 = as.numeric(0.02))
#'
#'rownames(df) <- "TP53"
#'
#'merged.df <- mergeProbability(df)
#'
#'}
#'@return merged.df

mergeProbability <- function(df){

    t.secretory.df <- data.frame(df[, colnames(df)[2:5]])
    t.secretory.df$Secretory <- rowSums(t.secretory.df)
    t.nuclear.df <- data.frame(df[, colnames(df)[6:9]])
    t.nuclear.df$Nuclear <- rowSums(t.nuclear.df)
    t.cytosol.df <- data.frame(df[, colnames(df)[10:14]])
    t.cytosol.df$Cytosol <- rowSums(t.cytosol.df)
    t.Mitochondria.df <- data.frame(df[, colnames(df)[15:16]])
    t.Mitochondria.df$Mitochondria <- rowSums(t.Mitochondria.df)

    merged.df <- data.frame(Proteins = rownames(df),
                            svm.pred.all = df[,colnames(df)[1]],
                            Secretory = t.secretory.df$Secretory,
                            Nuclear = t.nuclear.df$Nuclear,
                            Cytosol = t.cytosol.df$Cytosol,
                            Mitochondria = t.Mitochondria.df$Mitochondria)
    # temp neihborhood df
    t.n.df <- merged.df[,3:6]
    merged.df$svm.pred.all <- colnames(t.n.df)[apply(t.n.df, 1, which.max)]
    rownames(merged.df) <- merged.df$Proteins
    return(merged.df)
}

#' @title Gefitinib treated HCC827 Cell Line
#' @description HCC827 cell line was treated with Gefitinib which is
#' EGFR inhibition.
#' @name hcc827GEF
#' @docType data
#' @usage hcc827GEF
#' @format A data frame where 10398 protein gene-centric ids and 5
#' replicated subcellular fractions with duplicates.
#' @keywords datasets
#' @examples {
#'head(hcc827GEF)
#'}
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#'@title Evaluate marker protein coverage
#'@description Given the proteomics data, number of overlapped marker
#'proteins is calculated.
#'Bar plot for each compartment is plotted.
#'@param proteinIDs  character; gene symbol id
#'@param markerproteins character; 3365 proteins gene symbol ids
#'@import ggplot2
#'@importFrom graphics plot
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'}
#'@return covered.proteins

calculateCoveredProtein <- function(proteinIDs, markerproteins){

    compartments <- c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4",
                        "C1", "C2", "C3", "C4", "C5", "M1", "M2")

    color.code <- c("gold", "orange", "salmon", "tomato2", "grey90",
                "grey70", "grey50", "grey30", "lightblue", "aquamarine",
                "cyan", "deepskyblue2", "turquoise3", "burlywood4", "tan4")

    compartment.size <- c(358, 351, 252, 174, 192, 121, 231, 198, 242,
                            132, 220, 215, 341, 69, 269)


    covered.proteins <- intersect(proteinIDs, markerproteins)

    if( length(covered.proteins) < 1)
        stop('There is no overlap between marker proteins and data!')

    c.marker.df <- SubCellBarCode::markerProteins[covered.proteins, ]

    coverageCompWise <- lapply(seq_len(length(compartments)), function(x){
    temp.df <- c.marker.df[c.marker.df$Compartments == compartments[x], ]
    values <- list(Compartments = compartments[x],
            ColorCode = color.code[x],
            ProteinCoverage = 100 * ((dim(temp.df)[1]) / compartment.size[x]))
    })

    coverage.df <- as.data.frame(do.call("rbind", coverageCompWise))

    #check if there is not enough enrichemnt in any compartment
    non.enriched.loc <- coverage.df[coverage.df$ProteinCoverage < 20, ]
    if(nrow(non.enriched.loc) == 1){
        warning("There is not enough enrichment at: ",
                as.character(non.enriched.loc$Compartments),
                "\nWe recommend you to perform the fractionation, again.")
    }else if(nrow(non.enriched.loc) > 1){
        comp <- paste(as.character(non.enriched.loc$Compartments),
                collapse = ",")
        warning("There are not enough enrichments at: ",
                comp, "\nWe recommend you to perform the fractionation!")
    }


    coverage.df$ProteinCoverage <- as.numeric(coverage.df$ProteinCoverage)
    coverage.df$Compartments <- as.character(coverage.df$Compartments)
    coverage.df$ColorCode <- as.character(coverage.df$ColorCode)

    print(ggplot(data = coverage.df,
        aes(x = Compartments, y = ProteinCoverage)) +
        geom_bar(stat="identity", fill = coverage.df$ColorCode) +
        scale_x_discrete(limits=c(compartments)) +
        theme_bw() +
        theme(text = element_text(size = 16),
                plot.title = element_text(hjust = 0.5),
                axis.text.x = element_text(face = "bold", color="black"),
                axis.text.y = element_text(face = "bold", color="black")) +
        labs(title = "Marker Protein Coverage Compartment-Wise",
            y = "% Protein Coverage",
            x = "Compartment"
        ))

    coverage <- round(length(covered.proteins) / length(markerproteins), 2)
    cat("Overall Coverage of marker proteins : ", coverage)

    return (covered.proteins)
}

#'@title Load the fractionated proteomics data
#'@description Sampled median normalized TMT ratios are checked if
#'there is any "NA" valeus. If any, the corresponding
#'row is filtered out. Later, the data is normalized by taking log2.
#'@param protein.data data.frame; fractionated proteomics data where
#'data contains 10 columns of duplicated 5 fractionations and
#'rownames must be gene-centric protein names
#'@importFrom stats na.omit
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl[1:20,])
#'}
#'@return protein.data.df

loadData <- function(protein.data){

    if(! is.data.frame(protein.data))
        stop('Input must be a data frame format! Type ?loadData')

    if(! ncol(protein.data) == 10)
        stop('Input data must have 10 columns! Type ?loadData')

    if (! is.character(rownames(protein.data)))
        stop('Rownames must be character!')


    if(sum(is.na(protein.data)) > 0){

        protein.data <- na.omit(protein.data)
        if(sum(protein.data < 0) > 0){
            protein.data.df <- protein.data
            warning("Input data.frame has negative values.
Presumably, data was normalized. Therefore, log normalization
was not performed.")
        }else{
            protein.data.df <- log2(protein.data)
            cat("Rows with NA values were filtered.")
        }


    }else{
        if(sum(protein.data < 0) > 0){
            protein.data.df <- protein.data
            warning("Input data.frame has negative values.
Presumably, data was normalized. Therefore, log
normalization was not performed.")
        }else{
            protein.data.df <- log2(protein.data)
        }

    }
    return(protein.data.df)
}

#'@title Visualization of marker proteins by t-SNE map
#'@description The marker proteins are visualized in 3D t-SNE map
#'to see the distributions of the marker proteins.
#'@param markerProteins character; robust marker proteins, gene
#'symbols, that are present in the given data and overlapped with package's
#'marker protein list.
#'@param protein.data data.frame; fractionated proteomics data
#'@param dims integer; dimensionality
#'@param theta numeric; Speed/accuracy trade-off ,increase for less accuracy
#'@param perplexity integer; Perplexity parameter
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(21)
#'tsneMap.df <- tsneVisualization(protein.data = df,
#'markerProteins = c.prots[1:20],
#'dims = 2, theta = c(0.4), perplexity = c(5))
#'}
#'
#'@import Rtsne
#'@import scatterplot3d
#'@importFrom graphics legend
#'@return tsneMap.df

tsneVisualization <- function(protein.data,
                                markerProteins, dims,
                                theta,
                                perplexity){

    tsne.df <- protein.data[markerProteins, ]
    annotation.df <- SubCellBarCode::markerProteins[rownames(tsne.df), ]

    if( ! identical(rownames(tsne.df), rownames(annotation.df)) )
        stop('Make sure your markerProteins are covered in 3365 Proteins and
            there is no extra entry.')

    if(dims == 3){

        message("Optimization process started. This may take some time!")

        lst1 <- unlist(lapply(theta, function(x)
                lapply(perplexity, function(y) sort(x + y))))
        lst2 <- unlist(lapply(theta, function(x)
                lapply(perplexity, function(y){
                tsne.mpa <- Rtsne::Rtsne(tsne.df, dims=3, theta=x, perplexity=y)
                tsne.mpa$itercosts[1]})))

        lst.df <- data.frame(Parameters = lst1, Cost = lst2)
        lst.df <- lst.df[order(lst.df$Cost, decreasing = FALSE), ]


        min.theta.perp <- unlist(strsplit(as.character(lst.df[1, 1]),
                                split = ".", fixed = TRUE))

        message("Optimization was performed.")

        #get the optimization parameters
        theta.val <- as.numeric(paste(0,
                        as.character(min.theta.perp[2]), sep = "."))

        perplexity.val <- as.numeric(min.theta.perp[1])

        cat("Theta value: ", theta.val)
        cat("\nPerplexity value: ", perplexity.val)


        rtsne.map <- Rtsne::Rtsne(tsne.df,
                        dims = 3,
                        theta= theta.val,
                        perplexity = perplexity.val)


        #plot 3D tsne-map
        d <- data.frame(x=rtsne.map$Y[, 1],
                        y=rtsne.map$Y[, 2],
                        z=rtsne.map$Y[, 3])

        scatterplot3d::scatterplot3d(d$y, d$x, d$z,
                                    pch=20,
                                    color=annotation.df$Colour,
                                    grid = TRUE,
                                    box = FALSE)
        legend("topright",
                legend = c("S1", "S2", "S3", "S4","N1", "N2", "N3", "N4",
                            "C1", "C2", "C3", "C4", "C5", "M1", "M2"),
                pch = 16,
                cex = 0.75,
                col = c("gold", "orange", "salmon", "tomato2",
                        "grey90","grey70", "grey50", "grey30",
                        "lightblue", "aquamarine", "cyan", "deepskyblue2",
                        "turquoise3", "burlywood4", "tan4"))

        scatterplot3d::scatterplot3d(d$x, d$y, d$z,
                                    pch=20,
                                    color=annotation.df$Colour,
                                    grid = TRUE,
                                    box = FALSE)
        legend("topright",
                legend = c("S1", "S2", "S3", "S4","N1", "N2", "N3", "N4",
                            "C1", "C2", "C3", "C4", "C5", "M1", "M2"),
                pch = 16,
                cex = 0.75,
                col = c("gold", "orange", "salmon", "tomato2",
                        "grey90", "grey70", "grey50", "grey30",
                        "lightblue","aquamarine", "cyan","deepskyblue2",
                        "turquoise3","burlywood4","tan4"))

        scatterplot3d::scatterplot3d(d$z, d$y, d$x,
                                    pch=20,
                                    color = annotation.df$Colour,
                                    grid = TRUE,
                                    box = FALSE)
        legend("topright",
                legend = c("S1", "S2", "S3", "S4","N1", "N2", "N3", "N4",
                            "C1", "C2", "C3", "C4", "C5", "M1", "M2"),
                pch = 16,
                cex = 0.75,
                col = c("gold", "orange", "salmon", "tomato2",
                        "grey90", "grey70", "grey50", "grey30",
                        "lightblue", "aquamarine", "cyan", "deepskyblue2",
                        "turquoise3", "burlywood4", "tan4"))

        tsneMap.df <- data.frame(Proteins = rownames(tsne.df), d[, seq_len(3)])

    }else if(dims == 2){

        message("Optimization process started. This may take some time!")

        lst1 <- unlist(lapply(theta,
                function(x) lapply(perplexity, function(y) sort(x + y))))
        lst2 <- unlist(lapply(theta,
                function(x) lapply(perplexity, function(y){
            tsne.mpa <- Rtsne::Rtsne(tsne.df, dims = 2, theta=x, perplexity=y)
            tsne.mpa$itercosts[1]})))

        lst.df <- data.frame(Parameters = lst1, Cost = lst2)
        lst.df <- lst.df[order(lst.df$Cost, decreasing = FALSE), ]


        min.theta.perp <- unlist(strsplit(as.character(lst.df[1, 1]),
                                split = ".", fixed = TRUE))

        message("Optimization was performed.")

        #get the optimization parameters
        theta.val <- as.numeric(paste(0,
                        as.character(min.theta.perp[2]), sep = "."))

        perplexity.val <- as.numeric(min.theta.perp[1])

        cat("Theta value: ", theta.val)
        cat("\nPerplexity value: ", perplexity.val)
        rtsne.map <- Rtsne::Rtsne(tsne.df,
                        dims = 2,
                        theta = theta.val,
                        perplexity = perplexity.val)

        #plot 2D tsne-map
        d <- data.frame(x=rtsne.map$Y[, 1],
                        y=rtsne.map$Y[, 2])

        plot(d$x, d$y, col = annotation.df$Colour, type = "p" , pch = 20)
        legend("topright",
                inset=c(-0.04,0),
                legend = c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4",
                            "C1", "C2", "C3", "C4", "C5", "M1", "M2"),
                pch = 16,
                cex = 0.75,
                xpd = TRUE,
                col = c("gold", "orange", "salmon", "tomato2",
                        "grey90", "grey70", "grey50", "grey30",
                        "lightblue", "aquamarine", "cyan", "deepskyblue2",
                        "turquoise3", "burlywood4", "tan4"))

        tsneMap.df <- data.frame(Proteins = rownames(tsne.df), d[, seq_len(2)])

    } else{

        stop("Plesae select the correct dimension. It is either 2 or 3.")

    }
}

#' @title Minimum PSM Count in HCC827 Gefitinib Cell Line.
#' @description Minimum PSM, Peptide Sequence Match, Count table
#' for HCC827 Gefitinib Cell Line.
#' @name hcc827GefPSMCount
#' @docType data
#' @usage hcc827GefPSMCount
#' @format A data frame where 10398 protein gene-centric ids minimum PSM count.
#' @keywords datasets
#' @examples {
#'head(hcc827GefPSMCount)
#'}
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#'@title Visualize the SubCellBarCode
#'@description Stacked bar plot are plotted for compartment and
#'neighborhood level with respect to classification probabilities.
#'@param sampleClassification data.frame; merged classification,
#'combination of compartment and neighborhood classification.
#'@param protein character; protein gene symbol name
#'@param s1PSM data.frame; minimum PSM count table. Row names should
#'be gene centric protein id.
#'@export
#'@examples {
#'
#'#create mock data
#'plot.df <- data.frame(Protein = "TP53",
#'NeighborhoodCls = "Nuclear",
#'CompartmentCls = "N1",
#'Secretory = as.numeric(0.01),
#'Nuclear = as.numeric(0.95),
#'Cytosol = as.numeric(0.02),
#'Mitochondria = as.numeric(0.02),
#'S1 = as.numeric(0.02),
#'S2 = as.numeric(0.02),
#'S3 = as.numeric(0.02),
#'S4 = as.numeric(0.02),
#'N1 = as.numeric(0.72),
#'N2 = as.numeric(0.02),
#'N3 = as.numeric(0.02),
#'N4 = as.numeric(0.02),
#'C1 = as.numeric(0.02),
#'C2 = as.numeric(0.02),
#'C3 = as.numeric(0.02),
#'C4 = as.numeric(0.02),
#'C5 = as.numeric(0.02),
#'M1 = as.numeric(0.02),
#'M2 = as.numeric(0.02))
#'
#'rownames(plot.df) <- "TP53"
#'
#'psm.df <- data.frame(Protein = "TP53",
#'PSMs.for.quant = as.numeric(31))
#'
#'rownames(psm.df) <- "TP53"
#'
#'proteinPlot <- plotBarcode(plot.df, "TP53", psm.df)
#'}
#'@import ggplot2
#'@importFrom graphics plot
#'@return proteinPlot


plotBarcode <- function(sampleClassification, protein, s1PSM){

    p.df <- sampleClassification[as.character(protein),]

    if( sum(is.na(p.df)) > 0 )
        stop('Invalid protein name.
            Please make sure the protein is in the classification output.')

    comp.df <- data.frame(Locs = as.character(colnames(p.df[8:22])),
                            Probability = as.numeric(unname(t(p.df[1,8:22]))),
                            Level = "Compartment")

    neigh.df <- data.frame(Locs = as.character(colnames(p.df[4:7])),
                            Probability = as.numeric(unname(t(p.df[1,4:7]))),
                            Level = "Neighborhood")

    cols <- c("S1" = "gold", "S2" = "orange", "S3" = "salmon",
                "S4" = "tomato2", "N1" = "grey90", "N2" = "grey70",
                "N3" = "grey50", "N4" = "grey30", "C1" = "lightblue",
                "C2" = "aquamarine", "C3" = "cyan", "C4" = "deepskyblue2",
                "C5" = "turquoise3", "M1" = "burlywood4", "M2" = "tan4",
                "Cytosol" = "cadetblue1", "Secretory" = "goldenrod1",
                "Nuclear" = "grey80", "Mitochondria" = "peru")

    df <- rbind(comp.df, neigh.df)

    df$Locs <- factor(df$Locs,
                    levels = c("Nuclear", "Secretory", "Cytosol",
                                "Mitochondria", " ", "S1", "S2", "S3", "S4",
                                "N1", "N2", "N3", "N4", "C1", "C2", "C3",
                                "C4", "C5", "M1", "M2"))
    #get the PSM count
    psm <- as.numeric(s1PSM[protein,][2])

    if( length(psm) < 1 & !is.numeric(psm))
        stop('PSM count could not obtain properly.
            Please check the PSM input data')

    #calls for classification and probabilities
    c.c <- as.character(p.df[,3])
    if(c.c == "Unclassified"){
        c.p <- round(max(p.df[8:22]), 2)
    }else{
        c.p <- round(p.df[,c.c], 2)
    }


    n.c <- as.character(p.df[,2])
    if(n.c == "Unclassified"){
        n.p <- round(max(p.df[4:7]), 2)
    }else{
        n.p <- round(p.df[,n.c], 2)
    }

    #labels for the plot
    c.l <- sprintf("Call: %s \nProb: %s", c.c, c.p)
    n.l <- sprintf("Call: %s \nProb: %s", n.c, n.p)

    proteinPlot <- ggplot(df,
                        aes(x = Level,
                            y = Probability,
                            fill = Locs,
                            group = Probability)) +
                    geom_bar(stat = "identity",
                            position = "stack",
                            width = 0.5) +
                    facet_wrap(.~Level, scales = "free") +
                    scale_fill_manual(values = c(cols[seq_len(4)],
                                        "white",
                                        cols[5:19]),
                                        drop=FALSE) +
                    theme_bw() +
                        theme(text = element_text(size = 14),
                        strip.text.x = element_text(size = 12,
                                        colour = "dodgerblue4"),
                        axis.title.x=element_blank(),
                        axis.text.x = element_text(face = "bold",
                                                    color="black"),
                        plot.title = element_text(hjust = 0.5,
                                        color = "black",
                                        size=14),
                        legend.title = element_blank()) +
                    labs(title = paste(protein, "Classification", sep = " "),
                            y = "Probability",
                            caption = sprintf("#PSM: %s", psm)) +
                    scale_x_discrete(labels=c("Compartment" = c.l,
                                                "Neighborhood" = n.l))

    print(proteinPlot)
}

#'@title Merge compartment and neighborhood classification
#'@description Compartment and neighborhood classifications are merged
#'for the single output.
#'@param compartmentCls data.frame; all predictions, including
#'unclassified as well, and
#'probablity vectors for each protein in compartment classification
#'@param neighborhoodCls data.frame; all predictions, including
#'unclassified as well, and
#'probablity vectors for each protein in compartment classification
#'@export
#'@examples {
#'
#'#create mock data
#'com.df <- data.frame(Proteins = "TP53",
#'svm.pred = "N1",
#'S1 = as.numeric(0.02),
#'S2 = as.numeric(0.02),
#'S3 = as.numeric(0.02),
#'S4 = as.numeric(0.02),
#'N1 = as.numeric(0.72),
#'N2 = as.numeric(0.02),
#'N3 = as.numeric(0.02),
#'N4 = as.numeric(0.02),
#'C1 = as.numeric(0.02),
#'C2 = as.numeric(0.02),
#'C3 = as.numeric(0.02),
#'C4 = as.numeric(0.02),
#'C5 = as.numeric(0.02),
#'M1 = as.numeric(0.02),
#'M2 = as.numeric(0.02))
#'
#'rownames(com.df) <- "TP53"
#'
#'neig.df <- data.frame(Proteins = "TP53",
#'svm.pred.all = "Nuclear",
#'Secretory = as.numeric(0.01),
#'Nuclear = as.numeric(0.95),
#'Cytosol = as.numeric(0.02),
#'Mitochondria = as.numeric(0.02))
#'
#'rownames(neig.df) <- "TP53"
#'
#'cls.df <- mergeCls(com.df, neig.df)
#'
#'}
#'@return cls.df


mergeCls <- function(compartmentCls, neighborhoodCls){

    # get the same order of the proteins
    compartmentCls <- compartmentCls[rownames(neighborhoodCls),]

    if( ! identical(rownames(compartmentCls), rownames(neighborhoodCls)) )
        stop('Make sure your inputs files posses same rownames')


    cls.df <- data.frame(Protein = compartmentCls$Proteins,
                        NeighborhoodCls = neighborhoodCls$svm.pred.all,
                        CompartmentCls = compartmentCls$svm.pred,
                        neighborhoodCls[,3:6],
                        compartmentCls[,3:17])

    cls.df <- cls.df[order(cls.df$Protein, decreasing = FALSE),]

}

#'@title Visualization of multiple protein localizations
#'@description Distributions of subcellular localizations
#'of multiple proteins both ar the
#'compartment and neighborhood level are plotted.
#'@param sampleClassification data.frame; merged classification,
#'combination of compartment and neighborhood classifications
#'per protein.
#'@param proteinList vector; protein gene symbol names.
#'@export
#'@examples {
#'
#'proteasome26s <- c("PSMA7", "PSMC3", "PSMB1", "PSMA1", "PSMA3","PSMA4",
#'"PSMA5", "PSMB4", "PSMB6", "PSMB5","PSMC2", "PSMC4", "PSMB3", "PSMB2",
#'"PSMD4", "PSMA6", "PSMC1", "PSMC5", "PSMC6", "PSMB7", "PSMD13")
#'
#'exp.cls.df <- SubCellBarCode::hcc827GEFClass
#'
#'multipleProt.df <- plotMultipleProtein(exp.cls.df, proteasome26s )
#'
#'}
#'@import ggplot2
#'@import gridExtra
#'@return multipleProt.df


plotMultipleProtein <- function(sampleClassification, proteinList){

    protein.df <- sampleClassification[proteinList, ][, seq_len(3)]

    if( nrow(protein.df) < 1 )
        stop('Thre is no overlap between protein list and data')

    #check proteins that are not in the data
    not.exist.prot <- setdiff(proteinList, rownames(protein.df))

    # export the non-existing proteins
    if(length(not.exist.prot) > 0){
        message(sprintf("%s not exist in data",
            paste0(not.exist.prot, collapse = ",")))
    }

    protein.df <- protein.df[complete.cases(protein.df), ]

    multipleProt.df <- protein.df

    neighborhoods <- c("Secretory", "Nuclear", "Cytosol", "Mitochondria",
                        "Unclassified")
    compartments <- c("S1", "S2", "S3", "S4", "N1", "N2", "N3", "N4", "C1",
                        "C2", "C3", "C4", "C5", "M1", "M2", "Unclassified")

    neighCls <- lapply(neighborhoods, function(n){

        temp.n.df <- protein.df[protein.df$NeighborhoodCls == n, ]

        temp.df <- data.frame(Neighborhood = n,
                            Count = nrow(temp.n.df))

    })

    neigh.summay.df <- do.call("rbind", neighCls)

    neigh.cols <- c("Secretory" = "goldenrod1", "Nuclear" = "grey80",
                    "Cytosol" = "cadetblue1", "Mitochondria" = "peru",
                    "Unclassified" = "mistyrose")

    #bar plot of the neighborhood level classifications
    p1 <- ggplot(neigh.summay.df,
                aes(x = Neighborhood,
                    y = Count,
                    fill = Neighborhood)) +
            geom_bar(stat = "identity", position = "stack", width = 1) +
            scale_fill_manual(values = c(neigh.cols)) +
            labs(title = " ",
                    tag = "B",
                    y = "Protein Counts",
                    x = "Neighborhoods") +
            theme_minimal() +
            theme(text = element_text(size = 16),
                    legend.position="none",
                    axis.text.x = element_text(face = "bold",
                                                color="black",
                                                angle = 45,
                                                hjust = 1),
                    axis.text.y = element_text(face = "bold", color="black"))


    compCls <- lapply(compartments, function(n){

        temp.n.df <- protein.df[protein.df$CompartmentCls == n, ]

        temp.df <- data.frame(Compartment = n,
                                Count = nrow(temp.n.df))

    })

    comp.summay.df <- do.call("rbind", compCls)

    comp.cols <- cols <- c("S1" = "gold", "S2" = "orange", "S3" = "salmon",
                            "S4" = "tomato2", "N1" = "grey90", "N2" = "grey70",
                            "N3" = "grey50", "N4" = "grey30",
                            "C1" = "lightblue", "C2" = "aquamarine",
                            "C3" = "cyan", "C4" = "deepskyblue2",
                            "C5" = "turquoise3", "M1" = "burlywood4",
                            "M2" = "tan4", "Unclassified" = "mistyrose")

    #bar plot of the compartment level classifications
    p2 <- ggplot(comp.summay.df,
                aes(x = Compartment,
                    y = Count,
                    fill = Compartment)) +
                geom_bar(stat = "identity", position = "stack", width = 1) +
                scale_fill_manual(values = c(comp.cols)) +
                labs(title = " ",
                    tag = "A",
                    y = "Protein Counts",
                    x = "Compartments") +
                theme_minimal() +
                theme(text = element_text(size = 16),
                    legend.position="none",
                    axis.text.x = element_text(face = "bold",
                                                color="black",
                                                angle = 45,
                                                hjust = 1),
                    axis.text.y = element_text(face = "bold",
                                                color="black"))

    grid.arrange(p2, p1, ncol=2)
}

#'@title Compare exon and gene centric classifications
#'@description Comparison of the gene centric and exon
#'centric classification. Additionally, correlation analysis
#'is performed using quantification data.
#'@param geneCls, data frame gene centric classification output
#'@param exonCls, data frame exon centric classification output
#'@export
#'@examples {
#'
#'exon.cls <- data.frame(Protein = c("ENSE00000331854",
#'                                      "ENSE00000331855",
#'                                      "ENSE00000331859"),
#'                          NeighborhoodCls = c("Cytosol",
#'                                       "Cytosol",
#'                                       "Cytosol"),
#'                          CompartmentCls = c("C1","C1","C1"),
#'                          Secretory = c(0.1, 0.1, 0.1),
#'                          Nuclear = c(0.2, 0.2, 0.2),
#'                          Cytosol = c(0.2, 0.2, 0.2),
#'                          Mitochondria = c(0.2, 0.2, 0.2),
#'                          S1 = c(0.2, 0.2, 0.2),
#'                          S2 = c(0.2, 0.2, 0.2),
#'                          S3 = c(0.2, 0.2, 0.2),
#'                          S4 = c(0.2, 0.2, 0.2),
#'                          N1 = c(0.2, 0.2, 0.2),
#'                          N2 = c(0.2, 0.2, 0.2),
#'                          N3 = c(0.2, 0.2, 0.2),
#'                          N4 = c(0.2, 0.2, 0.2),
#'                          C1 = c(0.2, 0.2, 0.2),
#'                          C2 = c(0.2, 0.2, 0.2),
#'                          C3 = c(0.2, 0.2, 0.2),
#'                          C4 = c(0.2, 0.2, 0.2),
#'                          C5 = c(0.2, 0.2, 0.2),
#'                          M1 = c(0.2, 0.2, 0.2),
#'                          M2 = c(0.2, 0.2, 0.2),
#'                          GeneSymbol = c("COPB1", "COPB1", "COPB1"),
#'                          PeptideCount = c(2, 4, 7))
#'
#'gene.cls <- data.frame(Protein = c("COPB1"),
#'NeighborhoodCls = c("Cytosol"),
#'CompartmentCls = c("C1"),
#'Secretory = c(0.1),
#'Nuclear = c(0.2),
#'Cytosol = c(0.2),
#'Mitochondria = c(0.2),
#'S1 = c(0.2),
#'S2 = c(0.2),
#'S3 = c(0.2),
#'S4 = c(0.2),
#'N1 = c(0.2),
#'N2 = c(0.2),
#'N3 = c(0.2),
#'N4 = c(0.2),
#'C1 = c(0.2),
#'C2 = c(0.2),
#'C3 = c(0.2),
#'C4 = c(0.2),
#'C5 = c(0.2),
#'M1 = c(0.2),
#'M2 = c(0.2))
#'
#'comp.df <- compareCls(gene.cls, exon.cls)
#'
#'}
#'@return c.df

compareCls <- function(geneCls, exonCls){

    #overlap gene symbols between gene and exon centric
    os <- intersect(unique(exonCls$GeneSymbol), geneCls$Protein)

    # get the common symbols
    geneCls <- subset(geneCls, geneCls$Protein %in% os)
    geneCls <- geneCls[, seq_len(3)]

    # get the common symbols
    exonCls <- subset(exonCls, exonCls$GeneSymbol %in% os)
    exonCls <- exonCls[,c(1, 2, 3, 23, 24)]

    # merge classification between gene centric and exon centric
    comp.cls <- lapply(geneCls$Protein, function(g){
        gene.df <- subset(geneCls, geneCls$Protein %in% g)
        exon.df <- subset(exonCls, exonCls$GeneSymbol %in% g)
        c.df <- cbind(gene.df, exon.df, row.names = NULL)
    })

    c.df <- replaced.df <- do.call("rbind", comp.cls)

    #reorder the columns and rename
    c.df <- c.df[,c(4, 7, 2, 5, 3, 6, 8)]
    colnames(c.df) <- c("Exon_id","GeneSymbol",
                            "Gene_Neighborhood", "Exon_Neighborhood",
                            "Gene_Compartment", "Exon_Compartment",
                            "PeptideCount")

    #compute pearson correlation
    c.df$Pearson.Corr <- unlist(unname((lapply(rownames(c.df), function(i){
        e <- SubCellBarCode::hcc827exon[as.character(c.df[i,1]),][2:11]
        g <- SubCellBarCode::hcc827Ctrl[as.character(c.df[i,2]),][1:10]
        pear.cor <- cor(t(e), t(g), method = "pearson")
    }))))

    return(c.df)
}

#'@title Protein subcellular localization classification
#'@description Support Vector Machine classifier is trained and
#'used for prediction of protein subcellular localization
#'@param markerProteins character; robust marker proteins along
#' with subcellular localization that are present in the given data.
#'@param protein.data data.frame; fractionated proteomics data
#'@param markerprot.df data.frame; collection of marker proteins
#'along with corresponding subcellular localization
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 500)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'
#'}
#'@import caret
#'@import e1071
#'@importFrom stats predict
#'@return all.classifications

svmClassification <- function(markerProteins, protein.data, markerprot.df){

    prot.df <- protein.data[markerProteins, ]

    marker.df <- markerprot.df[markerProteins, ]

    subcell.loc.data <- cbind(prot.df, marker.df[seq_len(2)])

    #splitting the data
    label.train <- caret::createDataPartition(subcell.loc.data$Compartments,
                        times = 1,
                        p=0.7,
                        list = FALSE)

    df.train <- subcell.loc.data[label.train, ]
    df.test <- subcell.loc.data[-label.train, ]

    #build classifier for both replicate A and B, respectively.
    build.classifier <- lapply(c("A", "B"), function(x) {
        rep.train.df <- df.train[, grepl(sprintf("\\.%s\\.", x),
                                            colnames(df.train))]
                replicate.train.label <- df.train$Compartments

                rep.test.df <- df.test[, grepl(sprintf("\\.%s\\.", x),
                                            colnames(df.test))]
                replicate.test.label <- df.test$Compartments

                # tune the best parameters
                svm.tune <- e1071::tune(svm,
                                    train.x = rep.train.df,
                                    train.y = factor(replicate.train.label),
                                    kernel="radial",
                                    ranges=list(cost = 10^(seq_len(4) - 2),
                                    gamma = c(.5, 1, 1.5, 2)))

                # build the svm model
                model.svm <- e1071::svm(factor(replicate.train.label) ~ .,
                                        data = rep.train.df,
                                        probability=TRUE,
                                        kernel="radial",
                                        cost=svm.tune$best.parameters[1],
                                        gamma=svm.tune$best.parameters[2],
                                        scale = FALSE,
                                        cross=10)

                # predict and test on test data
                svm.pred <- predict(model.svm, rep.test.df, probability = TRUE)
                svm.pred.test.df <- data.frame(svm.pred)
                svm.test.prob <- data.frame(attr(svm.pred, "probabilities"))
                test.observation <- data.frame(df.test$Compartments)
                svm.test.prob.out <- cbind(test.observation,
                                            svm.pred.test.df,
                                            svm.test.prob)
                colnames(svm.test.prob.out)[1] <- 'Observation'
                svm.test.prob.out <- svm.test.prob.out[,
                                    c("Observation", "svm.pred", "S1", "S2",
                                    "S3", "S4", "N1", "N2", "N3", "N4", "C1",
                                    "C2", "C3", "C4", "C5", "M1", "M2")]

                if(sum(svm.test.prob.out$Observation ==
                        svm.test.prob.out$svm.pred) / nrow(df.test) < 0.50){

                    cat("Overall prediction accuracy is < % 50.
                        Downstream analysis will not be accurate enough.
                        We highly recommend you to perform wet-lab analyis
                        again.")
                }

                # predict all proteins
                all.prot.df <- protein.data[,grepl(sprintf("\\.%s\\.", x),
                                                        colnames(df.train))]
                svm.pred.all <- predict(model.svm,
                                        all.prot.df,
                                        probability = TRUE)

                svm.all.label <- data.frame(svm.pred.all)
                svm.all.prob <- data.frame(attr(svm.pred.all, "probabilities"))
                all.prot.pred <- cbind(svm.all.label, svm.all.prob)
                all.prot.pred <- all.prot.pred[,c("svm.pred.all", "S1", "S2",
                                    "S3", "S4", "N1", "N2", "N3", "N4", "C1",
                                    "C2", "C3", "C4", "C5", "M1", "M2")]

                # merge both test predicitions and all protein predictions
                all.classifications <- list(svm.test.prob.out=svm.test.prob.out,
                                        all.prot.pred = all.prot.pred,
                                        model = model.svm)

                return(all.classifications)

            })
}

#'@title Identify candidate relocated proteins
#'@description Identify candidate condition-dependent
#'relocated proteins by comparing neighborhood classifications
#'with respect to protein-protein pearson correlation and minumum PSM,
#'peptide spectrum matching, count.
#'@param sampleCls1 data.frame; merged classification,
#'combination of compartment and neighborhood classification.
#'@param s1PSM data.frame; minimum PSM count table
#'across ten TMT channel
#'@param s1Quant data.frame; fractionation quantification data
#'@param sampleCls2 data.frame; merged classification,
#'combination of compartment and neighborhood classification.
#'@param s2PSM data.frame; minimum PSM count table
#'across ten TMT channel
#'@param s2Quant data.frame; fractionation quantification data
#'@param annotation boolean; labeling the selected proteins
#'@param min.psm numeric; minimum psm, peptide spectra matching value
#'@param pearson.cor numeric; pearson correlation threshold
#'@export
#'@examples {
#'
#'candidate.df <- candidateRelocatedProteins(hcc827GEFClass, hcc827GefPSMCount,
#'hcc827GEF, hcc827GEFClass, hcc827GefPSMCount, hcc827GEF,
#'annotation = FALSE)
#'
#'
#'}
#'@import ggplot2
#'@import ggrepel
#'@importFrom graphics plot
#'@importFrom stats complete.cases
#'@return candidate.df

candidateRelocatedProteins <- function(sampleCls1, s1PSM,s1Quant, sampleCls2,
                                s2PSM, s2Quant, annotation = FALSE, min.psm = 2,
                                pearson.cor = 0.8){

    # just keep neighborhood classification
    df1 <- sampleCls1[, seq_len(2)]
    df2 <- sampleCls2[, seq_len(2)]

    df1 <- df1[intersect(rownames(df1), rownames(df2)), ]
    df2 <- df2[intersect(rownames(df1), rownames(df2)), ]

    df2 <- df2[rownames(df1), ]

    df <- data.frame(Protein = df1$Protein,
                        C.A = df1$NeighborhoodCls,
                        C.B = df2$NeighborhoodCls)

    #calculate the mean of duplicates
    s1Quant <- SubCellBarCode::calRowMean(s1Quant)
    s2Quant <- SubCellBarCode::calRowMean(s2Quant)

    #remove unclassfied proteins at both conditions
    f.df <- df[!grepl("Unclassified", df$C.A) & ! grepl("Unclassified",df$C.B),]
    rownames(f.df) <- f.df$Protein

    #protein pearson correlation between samples
    f.df$Pearson.Corr <- unlist(unname((lapply(rownames(f.df), function(x){
        condA.prot <- s1Quant[x,]
        condB.prot <- s2Quant[x,]
        pearson.cor <- cor(t(condA.prot), t(condB.prot), method = "pearson")
    }))))


    #PSMCount
    df1PSMCount <- s1PSM[rownames(f.df), ]
    df2PSMCount <- s2PSM[rownames(f.df), ]

    #Minumum PSM count between two condition
    psm.df <- data.frame(Condition1 = df1PSMCount$PSMs.for.quant,
                        Condition2 = df2PSMCount$PSMs.for.quant)
    f.df$Min.PSMs <- apply(psm.df, 1, min)

    f.df$Relocated <- ifelse(f.df$C.A == f.df$C.B, "Background", "Relocated")
    f.df$ColorCode <- ifelse(f.df$Relocated == "Relocated",
                                "steelblue1", "Black")
    f.df <- f.df[order(f.df$Relocated , decreasing = FALSE), ]

    Relocalization <- f.df$Relocated

    if( ! annotation){

        print(ggplot(f.df,
                aes(x = log2(f.df$Min.PSMs),
                    y = Pearson.Corr,
                    color = Relocalization))+
            geom_point(size = 2) +
            scale_colour_manual(values=c("Black","steelblue1")) +
            geom_hline(yintercept = pearson.cor,
                        linetype="dashed", color = "red") +
            geom_vline(xintercept = log2(min.psm),
                        linetype="dashed", color = "red") +
            theme_bw() +
            theme(text = element_text(size = 16),
                    axis.text.x = element_text(face = "bold", color="black"),
                    axis.text.y = element_text(face = "bold", color="black")) +
            labs(title = "",
                    y = "Pearson Correlation ",
                    x = "Log2(Min.PSM)"))

        f.df <- f.df[f.df$Relocated == "Relocated", ]

        candidate.df <- f.df[,c(seq_len(5))]
        candidate.df <- candidate.df[candidate.df$Pearson.Corr < pearson.cor &
                                        candidate.df$Min.PSMs > min.psm, ]

    }else{

        text.label.df <- subset(f.df, f.df$Pearson.Corr < pearson.cor &
                                    f.df$Min.PSMs > min.psm &
                                    f.df$Relocated == "Relocated")
        text.label.df$Label <- rownames(text.label.df)

        rem.df <- subset(f.df, !rownames(f.df) %in% rownames(text.label.df))
        rem.df$Label <- ""

        annot.df <- rbind(text.label.df, rem.df)
        annot.df <- annot.df[rownames(f.df),]

        Relocalization <- annot.df$Relocated
        print(ggplot(annot.df,
                    aes(log2(annot.df$Min.PSMs),
                        Pearson.Corr,
                        label = annot.df$Label,
                        color = Relocalization)) +
                geom_point(size = 2) +
                geom_text_repel() +
                scale_colour_manual(values=c("Black","steelblue1")) +
                geom_hline(yintercept = pearson.cor,
                            linetype="dashed", color = "red") +
                geom_vline(xintercept = log2(min.psm),
                            linetype="dashed", color = "red") +
                theme_bw() +
                theme(text = element_text(size = 16),
                    axis.text.x = element_text(face = "bold", color="black"),
                    axis.text.y = element_text(face = "bold", color="black")) +
                labs(title = "",
                    y = "Pearson Correlation ",
                    x = "Log2(Min.PSM)"))

        annot.df <- annot.df[annot.df$Relocated == "Relocated", ]

        candidate.df <- annot.df[, c(seq_len(5))]
        candidate.df <- candidate.df[candidate.df$Pearson.Corr < pearson.cor &
                                        candidate.df$Min.PSMs > min.psm, ]

    }
}

#' @title Marker Proteins Source
#' @description Data for the proteins whose localizations
#' were well characterized. It also contains color codes for each
#' compartment and median fractionation profiles for 5 fractions which are
#' Cyto., Nsol., NucI., Horg., Lorg., with replicates A and B. These
#' fractionation profiles will be used for the marker protein quality control.
#' @name markerProteins
#' @docType data
#' @usage markerProteins
#' @format A data frame of 3365 proteins as rows and 13 columns headers.
#' @keywords datasets
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#' @title HCC827 Control Exon Cell Line
#' @description Exon-centric sub data of hcc827 fractionated data.
#' @name hcc827exon
#' @docType data
#' @usage hcc827exon
#' @format A data frame where 500 exon-centric ensemble identifiers,
#' corresponding gene symbols, 5 replicated subcellular fractions
#' and number of unique peptides matched to associated exon.
#' @keywords datasets
#' @examples {
#'head(hcc827exon)
#'}
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#'@title Replace compartment predictions to neighborhood predictions
#'@description Compartment level classifications are replaced with
#'neighborhood level assignment. It is a helper function.
#'@param df data.frame; all predictions at the compartment level and
#'probablity vectors for each protein
#'@param column character; selected column in the data frame, df
#'@export
#'@examples {
#'
#'#define mock data frame
#'df <- data.frame(svm.pred.all = c("S1","S2","S3","S4",
#'"N1","N2","N3","N4",
#'"C1","C2","C3","C4","C5",
#'"M1","M2"))
#'
#'df$svm.pred.all <- as.character(df$svm.pred.all)
#'df$Prob <- "1"
#'
#'df <- replacePrediction(df, column = "svm.pred.all")
#'}
#'@return replaced.df

replacePrediction <- function(df,
                        column = c("svm.pred.all", "Observation", "svm.pred")){

    couple.lsit <- list(c("Secretory", "S1"), c("Secretory", "S2"),
                        c("Secretory", "S3"), c("Secretory", "S4"),
                        c("Nuclear", "N1"), c("Nuclear", "N2"),
                        c("Nuclear", "N3"), c("Nuclear", "N4"),
                        c("Cytosol", "C1"), c("Cytosol", "C2"),
                        c("Cytosol", "C3"), c("Cytosol", "C4"),
                        c("Cytosol", "C5"), c("Mitochondria", "M1"),
                        c("Mitochondria", "M2"))

    multiple.lst <- lapply(couple.lsit, function(f){
        temp.df <- df[df[column] == unname(unlist(f[2])), ]
        if(nrow(temp.df) > 0){
            temp.df[[column]] <- as.character(unname(unlist(f[1])))
            temp.df
        }
    })
    replaced.df <- do.call("rbind", multiple.lst)
}

#' @title HCC827 Control Cell Line
#' @description Subcellular fractionated cell line.
#' @name hcc827Ctrl
#' @docType data
#' @usage hcc827Ctrl
#' @format A data frame where 10480 protein gene-centric ids and
#' 5 replicated subcellular fractions.
#' @keywords datasets
#' @examples {
#'head(hcc827Ctrl)
#'}
#' @references Orre et al. 2019 Cell 73, 1-17
NULL

#'@title Peptide/exon/transcript centric or
#'PTM enriched classification
#'@description Peptide/exon/transcript centric or
#'PTM enriched classification is applied to predict
#'localization of them.
#'@param df, data frame fractionated additional data
#'@param modelA, model for the replicate A classification
#'@param modelB, model for the replicate B classification
#'@import caret
#'@import e1071
#'@export
#'@examples {
#'
#'df <- loadData(SubCellBarCode::hcc827Ctrl)
#'
#'c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
#'
#'set.seed(7)
#'c.prots <- sample(c.prots, 550)
#'cls <- svmClassification(c.prots, df, markerProteins)
#'modelA <- cls[[1]]$model
#'modelB <- cls[[2]]$model
#'
#'exon.cls <- svmExternalData(SubCellBarCode::hcc827exon,
#'modelA = modelA, modelB = modelB)
#'}
#'@return c.cls.df

svmExternalData <- function(df, modelA, modelB){

    Cls <- lapply(c("A", "B"), function(x) {
        if(x == "A"){
            all.prot.df <- df[,grepl(sprintf("\\.%s\\.", x),
                                        colnames(df))]

            #take log normalization if it was not
            if(sum(all.prot.df < 0) >= 0){
                all.prot.df <- log2(all.prot.df)
            }

            # get the model
            svm.mod1 <- modelA

            # make prediction
            svm.pred.all <- predict(svm.mod1,
                                    all.prot.df,
                                    probability = TRUE)

            svm.all.label <- data.frame(svm.pred.all)
            svm.all.prob <- data.frame(attr(svm.pred.all, "probabilities"))
            all.prot.pred <- cbind(df[,1], svm.all.label, svm.all.prob)
            colnames(all.prot.pred)[1] <- "Gene_Symbol"
            all.prot.pred <- all.prot.pred[,c("Gene_Symbol","svm.pred.all",
                                            "S1", "S2", "S3", "S4", "N1",
                                            "N2", "N3", "N4", "C1",
                                            "C2", "C3", "C4", "C5",
                                            "M1", "M2")]


        }else{
            all.prot.df <- df[,grepl(sprintf("\\.%s\\.", x),
                                     colnames(df))]

            #take log normalization if it was not
            if(sum(all.prot.df < 0) >= 0){
                all.prot.df <- log2(all.prot.df)
            }

            # get the model
            svm.mod2 <- modelB

            # make prediction
            svm.pred.all <- predict(svm.mod2,
                                    all.prot.df,
                                    probability = TRUE)

            svm.all.label <- data.frame(svm.pred.all)
            svm.all.prob <- data.frame(attr(svm.pred.all, "probabilities"))
            all.prot.pred <- cbind(df[,1], svm.all.label, svm.all.prob)
            colnames(all.prot.pred)[1] <- "Gene_Symbol"
            all.prot.pred <- all.prot.pred[,c("Gene_Symbol","svm.pred.all",
                                            "S1", "S2", "S3", "S4", "N1",
                                            "N2", "N3", "N4", "C1",
                                            "C2", "C3", "C4", "C5",
                                            "M1", "M2")]
        }
    })}

---
title: "SubCellBarCode: Integrated workflow for robust classification and 
visualization of spatial proteome"
author:
- name: Taner Arslan
  affiliation: "Karolinska Institute, Stockholm, Sweden"
- name: Lukas Orre
  affiliation: "Karolinska Institute, Stockholm, Sweden"
- name: Mattias Vesterlund
  affiliation: "Karolinska Institute, Stockholm, Sweden"
- name: Yanbo Pan
  affiliation: "Karolinska Institute, Stockholm, Sweden"
- name: Janne Lehtiö
  affiliation: "Karolinska Institute, Stockholm, Sweden"
date: "`r Sys.Date()`"
output: 
    BiocStyle::html_document:
        toc_fload: true
package: SubCellBarCode
abstract: In the SubCellBarCode project, mass spectrometry (MS) 
    based proteomics was used for proteome-wide mapping of protein 
    subcellular localization (Orre et al. 2019, Molecular Cell). 
    Subcellular fractionation and MS-based quantification can be 
    reproduced following the methods described in Orre et al. 
    Here, the SubCellBarCode R package offers tools to reproduce 
    the underlying bioinformatics pipeline for robust classification 
    and visualization of proteins into corresponding subcellular 
    localizations. Moreover, the R-package can be used for differential 
    localization analysis to investigate e.g. treatment induced protein 
    relocalization, condition dependent localization or cell type 
    specific localization. Last but not least, it provides peptide/
    exon/transcript centric classification as well as PTM (Post 
    translation modifications) modified peptide classification. 
vignette: >
    %\VignetteIndexEntry{SubCellBarCode R Markdown vignettes}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---
                                                                                
# Installation of the package

                                                                                
`SubCellBarCode` can be installed through `BiocManager` package as follows:

``` {r install,eval = FALSE}
if (!requireNamespace("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("SubCellBarCode")
``` 

# Load the package

```{r Loadpackage}
library(SubCellBarCode)
```

# Data preparation and classification 
## Example Data
As example data we here provide the publicly available HCC827 (human lung 
adenocarcinoma cell line) TMT10plex labelled proteomics dataset 
(*Orre et al.* 2019, Molecular Cell). The `data.frame` consists of 
10480 proteins as rows (rownames are gene -centric protein ids) 
and 5 fractions with duplicates as columns 
(replicates must be named ".A." and ".B.", repectively). 
                                                                                
```{r exampleData}
head(hcc827Ctrl)
```

## Marker Proteins
The classification of protein localisation using the SubCellBarCode 
method is dependent on 3365 marker proteins as defined in Orre et al. 
The markerProteins `data.frame` contain protein names (gene symbol), 
associated subcellular localization (compartment), color code for 
the compartment and the median normalized fractionation
profile (log2) based on five different human cell lines 
(NCI-H322, HCC827, MCF7, A431and U251) here called the 
“5CL marker profile”.


```{r markerdata}
head(markerProteins)
```

## Load and normalize data
Input `data.frame` is checked with *"NA"* values and for the correct 
format. If there is any *"NA"* value, corresponding row is deleted. 
Then, data frame is `log2` transformmed. 

```{r loadData}
df <- loadData(protein.data = hcc827Ctrl)
```


```{r printDimData}
cat(dim(df))
head(df)
```

**Additional step:**
We use gene symbols for the protein identification. Therefore, we require 
gene symbols for the identifiaction. However, if the input data has 
other identifier e.g. UNIPROT, IPI, Entrez ID, you can convert it to gene
symbol by our defined function.   
*Please be aware of possible (most likely few) id loss during the 
conversion to one another.*

```{r convertID}
##Run if you have another identifier than gene symbols.
##Function will convert UNIPROT identifier to gene symbols.
##Deafult id is "UNIPROT", make sure you change it if you use another.

#df <- convert2symbol(df = df, id = "UNIPROT")
```

For the downstream analysis, we used the randomly selected subset data. 
```{r subset data}
set.seed(2)
df <- df[sample(nrow(df), 6000),]
```

## Calculate covered marker proteins
The overlap between *marker proteins (3365)* and 
*input data.frame* is calculated and visualized for each 
compartment by a bar plot.    

*Note that we recommend at least 20% coverage of marker proteins 
for each compartment. If certain compartments are underrrepresented 
we recommend you to perform the cell fractionation again. 
If all compartments are low in coverage we recommend increasing 
the analytical depth of the MS-analysis.* 

```{r coverageMarkers, fig = TRUE}
c.prots <- calculateCoveredProtein(proteinIDs = rownames(df), 
                        markerproteins = markerProteins[,1]) 
```
                                                                                
## Quality control of the marker proteins
To avoid reduced classification accuracy, marker proteins with 
noisy quantification and marker proteins that are not representative 
of their associated compartment (e.g.due to cell type specific 
localization) are filtered out by a two-step quality control. 


1. Marker proteins with pearson correlations 
less than 0.8 between *A* and *B* duplicates for each cell line were 
filtered out (Figure A).  

2. Pairwise correlations between 5CL marker profile and input data for 
each protein (A and B replicate experiments separately) were calculated 
using both Pearson and Spearman correlation. The lowest value for each 
method were then used for filtering with cut-offs set to 0.8 and 0.6 
respectively, to exclude non-representative marker proteins (Figure B).

```{r markerQC}
r.markers <- markerQualityControl(coveredProteins = c.prots,protein.data = df)
r.markers[1:5]
```

**Optional step:** After removing non-marker proteins, you can re-calculate 
and visualize the final coverage of the marker proteins.

```{r finalCoverage, fig = TRUE}
## uncomment the function when running 
# f.prots <- calculateCoveredProtein(r.markers, markerProteins[,1])
```
                                                                                
## Visualization of marker proteins in t-SNE map
The spatial distribution of the marker proteins is visualized in 
t-SNE map. This plot will be informative for the quality control 
of the generated data as it offers evaluation of the spatial 
distribution and separation of marker proteins. 


```{r tsneparameter}
#Default parameters
#Run the broad-range parameters to optimize well !!!
#Output dimensionality
#dims = 3
#Speed/accuracy trade-off (increase for less accuracy) 
#theta = c(0.1, 0.2, 0.3, 0.4, 0.5)
#Perplexity parameter
#perplexity = c(5, 10, 20, 30, 40, 50, 60) 
```

Information about the different t-SNE parameters that can be 
modified by the user is available by typing `?Rtsne` in the console.    
Although the applications of t-SNE is widespread in the field 
of machine learning, it can be misleading if it is not well 
optimized. Therefore, we optimize t-SNE map by grid search, 
a process that can take some time 

```{r tsnedim3, fig = TRUE, fig.width = 6.5, fig.height = 6.5}
set.seed(6)
tsne.map <- tsneVisualization(protein.data = df, 
                    markerProteins = r.markers, 
                    dims = 3, 
                    theta = c(0.1), 
                    perplexity = c(60)) 
```

We recommend 3D vizualisation by setting `dims = 3`, 
for optimal evaluation of marker protein cluster separation 
and data modularity. You can also visualize the marker 
proteins in 2 dimensional space by setting `dims = 2`, although 
reducing the dimensionality results in loss of information and 
underestimation of data resolution. 


```{r tsnedim2, fig = TRUE}
set.seed(9)
tsne.map2 <- tsneVisualization(protein.data = df, 
                    markerProteins = r.markers, 
                    dims = 2, 
                    theta = c(0.5), 
                    perplexity = c(60))
```

## Build model and classify proteins
For replicate *A* and *B* separately, marker proteins are 
used for training a Support Vector Machine (SVM) classifier 
with a Gaussian radial basis function kernel algorithm. 
After tuning the parameters, the SVM model predicts (classifies) 
the subcellular localization for all proteins in the input 
data with corresponding probabilities for *A* and *B* replicate 
classification.


```{r buildSVM}
set.seed(4)
cls <- svmClassification(markerProteins = r.markers, 
                                    protein.data = df, 
                                    markerprot.df = markerProteins)
```

```{r testdata}
# testing data predictions for replicate A and B
test.A <- cls[[1]]$svm.test.prob.out
test.B <- cls[[2]]$svm.test.prob.out
head(test.A)
```

```{r allPred}
# all predictions for replicate A and B
all.A <- cls[[1]]$all.prot.pred
all.B <- cls[[2]]$all.prot.pred
```
                                                                                
### Estimate classification thresholds for compartment level
Classification probabilities close to 1 indicate high confidence 
predictions, whereas probabilities close to 0 indicate low 
confidence predictions. To increase the overal prediction accuracy 
and to filter out poor predictions, one criterion and 
two cut-offs are defined.

1. The criterion is the consensus of preliminary predictions 
between biological duplicates. Proteins are kept in the analysis, 
if there is an agreement between biological duplicates. 
Subsequently, prediction probabilities from the two 
duplicates are averaged for each protein.  

2. Cut-off is (precision - based) set when precision reach 0.9 
in the test data.  

3. Cut-off is (recall - based) set as the probability of the 
lowest true positive in the test data.

```{r compartmentThreshold}
t.c.df <- computeThresholdCompartment(test.repA = test.A, test.repB = test.B)
```

```{r headcompartmentThreshold}
head(t.c.df)
```

### Apply threshold to compartment level classifications
The determined thresholds for the compartment levels are applied 
to all classifications.

```{r applycompartmentThreshold}
c.cls.df <- applyThresholdCompartment(all.repA = all.A, all.repB = all.B,
                                    threshold.df = t.c.df)
```

```{r headcompartmentCls}
head(c.cls.df)
```

### Estimate classification thresholds for neighborhood level
Compartment level classification probabilities are summed to 
neighborhood probabilities and thresholds for neighborhood 
analysis are estimated as described above for compartment 
level analysis except precision based cut-off is set to 0.95.  

```{r neighborhoodThreshold}
t.n.df <- computeThresholdNeighborhood(test.repA = test.A, test.repB = test.B)
```

```{r headneighborhoodThreshold}
head(t.n.df)
```

### Apply threshold to neighborhood level classifications
The determined thresholds for the neighborhood levels are applied to all 
classifications.

```{r applyNeighborhoodThreshold}
n.cls.df <- applyThresholdNeighborhood(all.repA = all.A, all.repB = all.B, 
                                    threshold.df = t.n.df)
```

```{r headNeighborhoodCls}
head(n.cls.df)
```

### Merge compartment and neighborhood classification
Individual classifications (compartment and neighborhood) are merged 
into one data frame. 

```{r mergecls}
cls.df <- mergeCls(compartmentCls = c.cls.df, neighborhoodCls = n.cls.df)
```

```{r headmerge}
head(cls.df)
```

# Visualization of the protein subcellular localization
## SubCellBarCode plot
You can query one protein at a time to plot barcode of the protein 
of the interest.    

`PSM` (Peptide-spectra-matching) count table is required for the plotting
SubCellBarCode. It is in `data.frame` format;

```{r hcc827psmcount}
head(hcc827CtrlPSMCount)
```

```{r plotbarcode, fig = TRUE, fig.width = 6, fig.height = 6}
plotBarcode(sampleClassification = cls.df, protein = "NLRP4",
        s1PSM = hcc827CtrlPSMCount)
```

## Co-localization plot
To evaluate localization and of multiple proteins at 
the same time, a vector of proteins (identified by gene symbols) 
can be prepared and used to create a barplot showing the 
distribution of classifications across compartments and 
neighborhoods. This analysis could be helpful when 
evaluating co-localization of proteins, protein complex 
formation and compartmentalized protein level regulation.


```{r multipleprots, fig = TRUE, fig.width= 10, fig.height = 8}
# 26S proteasome complex (26s proteasome regulatory complex)
proteasome26s <- c("PSMA7", "PSMC3","PSMA4", "PSMB4", 
                    "PSMB6", "PSMB5", "PSMC2","PSMC4",
                    "PSMB3", "PSMA6","PSMC5","PSMC6")

plotMultipleProtein(sampleClassification = cls.df, proteinList = proteasome26s)
```

# Differential localization analysis
Regulation of  protein localization is a the key 
process in cellular signalling. The `SubCellBarCode` 
method can be used for differential localization analysis 
given two conditions such as control vs treatment, cancer
cell *vs* normal cell, cell state A *vs* cell state B, *etc*. 
As example, we compared untreated and gefitinib (EGFR inhibitor) 
treated HCC827 cells (for details, see Orre et al.). 

## Plot differentially localizing proteins
Neighborhood classifications  for condition 1 (untreated) and 
condition 2 (gefitinib) is first done separately, and 
classifications for overlapping proteins are then vizualized by a 
sankey plot.     
*The HCC827 gefitinib cell lines classification was embedded 
into the package for example analysis.*


```{r headHCC827GEFCls}
head(hcc827GEFClass)
```

```{r sankey, fig.width = 6, fig.height = 3}
sankeyPlot(sampleCls1 = cls.df, sampleCls2 = hcc827GEFClass)
```

## Filter Candidates
As the differential localization analysis is an outlier analysis, 
it will include analytical noise. To filter out such noise, 
`PSM` (Peptide-spectra-matching) counts and fractionation profile 
correlation analysis (Pearson) was done to identify strong 
candidates. The PSM count format for the input have to be the 
same between the compared conditions;


```{r headPSMCount}
head(hcc827CtrlPSMCount)
```

For each protein, the minimum PSM count between the two conditions 
is plotted against the fractionation profile (median) correlation 
between the two conditions. For proteins with different localizations 
between conditions, the fractionation profile differs and therefore 
we are expecting a low fractionation profile correlation. As a standard 
setting for filtering of analytical noise in the differential 
localization analysis we suggest to demand a fractionation profile 
correlation below 0.8, and a minimum PSM count of at least 3.   
However, for the exploratory analysis, you can adjust
the `min.psm` and `pearson.cor` parameters. 

```{r relocation parameters}
##parameters
#sampleCls1 = sample 1 classification output
#s1PSM = sample 2 PSM count
#s1Quant = Sample 1 Quantification data
#sampleCls2 = sample 2 classification output
#s2PSM = sample 2 classification output
#sample2Quant = Sample 2 Quantification data
#min.psm = minumum psm count
#pearson.cor = perason correlation coefficient
```

```{r strongCandidates, fig = TRUE}
candidate.df <- candidateRelocatedProteins(sampleCls1 = cls.df, 
                                s1PSM = hcc827CtrlPSMCount, 
                                s1Quant = hcc827Ctrl,
                                sampleCls2 = hcc827GEFClass,
                                s2PSM = hcc827GefPSMCount,
                                s2Quant = hcc827GEF,
                                min.psm = 2,
                                pearson.cor = 0.8)
```

```{r printdim}
cat(dim(candidate.df))
```

```{r printhead}
head(candidate.df)
```

Candidate subset of differentially localizing proteins can 
be annotated with names by setting `annotation = TRUE`, `min.psm` 
and `pearson.cor` 

```{r strongCandidatesLabel, fig = TRUE}
candidate2.df <- candidateRelocatedProteins(sampleCls1 = cls.df,
                                s1PSM = hcc827CtrlPSMCount, 
                                s1Quant = hcc827Ctrl, 
                                sampleCls2 = hcc827GEFClass, 
                                s2PSM = hcc827GefPSMCount, 
                                s2Quant = hcc827GEF, 
                                annotation = TRUE, 
                                min.psm = 9, 
                                pearson.cor = 0.05) 
```

# Peptide/Exon/Transcript centric or PTM regulated localization
Our main analysis is based on gene-centric. However, based on the analytical
depth of the data, peptide/exon/transcript centric classifications can
be performed. Moreover, this approach is also applicable for
post translation modification (PTM) enriched data.  
Fundamentally, we will use the same classifiers, compartment 
and neighborhood levels thresholds and apply 
them to peptide/exon/transcript data. 

## Exon-centric classification
Here, we have provided subset of the HCC827 exon-centric data. 

```{r head exon data}
head(hcc827exon)
```

For the classification, we will use the gene-centric model that we built in 
section 3.7.

```{r recall model}
##recall the models
modelA <- cls[[1]]$model
modelB <- cls[[2]]$model
```

*`svmExternalData` function greps replicates A and B, repectively. So 
the input data can include other features like, here, peptide counts.* 

```{r exon centric cls}
exon.cls <- svmExternalData(df = hcc827exon, modelA = modelA, modelB= modelB)
```


```{r exon cls}
exon.A <- exon.cls[[1]]
exon.B <- exon.cls[[2]]
```

```{r exon cls rep A}
head(exon.A)
```

Next steps are exactly same as what we did in section 3.7. We will 
use same thresholdsthat we have estimated in 3.7.1 and 3.7.3. 
Finally, we will merge two classifications same function used 
in 3.7.5.

```{r apply thresholds}
exon.comp.cls <- applyThresholdCompartment(all.repA = exon.A[,2:17], 
                                    all.repB = exon.B[,2:17],
                                    threshold.df = t.c.df)

exon.neigh.cls <- applyThresholdNeighborhood(all.repA = exon.A[,2:17], 
                                    all.repB = exon.B[,2:17], 
                                    threshold.df = t.n.df)

exon.cls.df <- mergeCls(compartmentCls = exon.comp.cls, 
                        neighborhoodCls = exon.neigh.cls)

#same order
exon.cls.df <- exon.cls.df[rownames(exon.A),]

# we will add gene symbols as well as peptide count  
# (PSM count is also accepted) in case for comparing with 
# gene-centric classifications

exon.cls.df$GeneSymbol <- exon.A$Gene_Symbol
exon.cls.df$PeptideCount <- hcc827exon$PeptideCount
```

```{r head exon cls}
head(exon.cls.df)
```

## Comparison between gene and exon centric classification
The insteresting part of the exon classification is to detect deviated 
classification between gene centric classification. However, we enrich
more noise than gene centric classification due to analtyical dept of the exon
centric data. Therefore, we, additioanlly, internally calculate correlation
between gene-centric data `hcc827Ctrl` and exon-centric data `hcc827exon`, 
and report
number of peptides (PSM count works, too) that match to corresponding exon 
as an indication of the confidence of the results.

```{r compareCls}
comp.df <- compareCls(geneCls = cls.df, exonCls = exon.cls.df)
```

```{r head comp.df}
head(comp.df)
```
You can easily vizualize/filter the results using correlations and number of peptides. 

# References

* Orre., et al. "SubCellBarCode: Proteome-wide Mapping of Protein 
Localization and Relocalization." Molecular Cell (2019): 73(1):166-182.e7. 

# Session Information

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeProbability.R
\name{mergeProbability}
\alias{mergeProbability}
\title{Merge compartment probabilities to neighborhood probabilities}
\usage{
mergeProbability(df)
}
\arguments{
\item{df}{data.frame; all predictions at the neighborhood level and
probablity vectors for each protein}
}
\value{
merged.df
}
\description{
Compartment levels classifications are summed up to
associated neighborhood levels. It is a helper function.
}
\examples{
{

#create mock data
df <- data.frame(Protein = "TP53",
S1 = as.numeric(0.02),
S2 = as.numeric(0.02),
S3 = as.numeric(0.02),
S4 = as.numeric(0.02),
N1 = as.numeric(0.72),
N2 = as.numeric(0.02),
N3 = as.numeric(0.02),
N4 = as.numeric(0.02),
C1 = as.numeric(0.02),
C2 = as.numeric(0.02),
C3 = as.numeric(0.02),
C4 = as.numeric(0.02),
C5 = as.numeric(0.02),
M1 = as.numeric(0.02),
M2 = as.numeric(0.02))

rownames(df) <- "TP53"

merged.df <- mergeProbability(df)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMultipleProtein.R
\name{plotMultipleProtein}
\alias{plotMultipleProtein}
\title{Visualization of multiple protein localizations}
\usage{
plotMultipleProtein(sampleClassification, proteinList)
}
\arguments{
\item{sampleClassification}{data.frame; merged classification,
combination of compartment and neighborhood classifications
per protein.}

\item{proteinList}{vector; protein gene symbol names.}
}
\value{
multipleProt.df
}
\description{
Distributions of subcellular localizations
of multiple proteins both ar the
compartment and neighborhood level are plotted.
}
\examples{
{

proteasome26s <- c("PSMA7", "PSMC3", "PSMB1", "PSMA1", "PSMA3","PSMA4",
"PSMA5", "PSMB4", "PSMB6", "PSMB5","PSMC2", "PSMC4", "PSMB3", "PSMB2",
"PSMD4", "PSMA6", "PSMC1", "PSMC5", "PSMC6", "PSMB7", "PSMD13")

exp.cls.df <- SubCellBarCode::hcc827GEFClass

multipleProt.df <- plotMultipleProtein(exp.cls.df, proteasome26s )

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotBarcode.R
\name{plotBarcode}
\alias{plotBarcode}
\title{Visualize the SubCellBarCode}
\usage{
plotBarcode(sampleClassification, protein, s1PSM)
}
\arguments{
\item{sampleClassification}{data.frame; merged classification,
combination of compartment and neighborhood classification.}

\item{protein}{character; protein gene symbol name}

\item{s1PSM}{data.frame; minimum PSM count table. Row names should
be gene centric protein id.}
}
\value{
proteinPlot
}
\description{
Stacked bar plot are plotted for compartment and
neighborhood level with respect to classification probabilities.
}
\examples{
{

#create mock data
plot.df <- data.frame(Protein = "TP53",
NeighborhoodCls = "Nuclear",
CompartmentCls = "N1",
Secretory = as.numeric(0.01),
Nuclear = as.numeric(0.95),
Cytosol = as.numeric(0.02),
Mitochondria = as.numeric(0.02),
S1 = as.numeric(0.02),
S2 = as.numeric(0.02),
S3 = as.numeric(0.02),
S4 = as.numeric(0.02),
N1 = as.numeric(0.72),
N2 = as.numeric(0.02),
N3 = as.numeric(0.02),
N4 = as.numeric(0.02),
C1 = as.numeric(0.02),
C2 = as.numeric(0.02),
C3 = as.numeric(0.02),
C4 = as.numeric(0.02),
C5 = as.numeric(0.02),
M1 = as.numeric(0.02),
M2 = as.numeric(0.02))

rownames(plot.df) <- "TP53"

psm.df <- data.frame(Protein = "TP53",
PSMs.for.quant = as.numeric(31))

rownames(psm.df) <- "TP53"

proteinPlot <- plotBarcode(plot.df, "TP53", psm.df)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/svmExternalData.R
\name{svmExternalData}
\alias{svmExternalData}
\title{Peptide/exon/transcript centric or
PTM enriched classification}
\usage{
svmExternalData(df, modelA, modelB)
}
\arguments{
\item{df, }{data frame fractionated additional data}

\item{modelA, }{model for the replicate A classification}

\item{modelB, }{model for the replicate B classification}
}
\value{
c.cls.df
}
\description{
Peptide/exon/transcript centric or
PTM enriched classification is applied to predict
localization of them.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

set.seed(7)
c.prots <- sample(c.prots, 550)
cls <- svmClassification(c.prots, df, markerProteins)
modelA <- cls[[1]]$model
modelB <- cls[[2]]$model

exon.cls <- svmExternalData(SubCellBarCode::hcc827exon,
modelA = modelA, modelB = modelB)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeCompNeigh.R
\name{mergeCls}
\alias{mergeCls}
\title{Merge compartment and neighborhood classification}
\usage{
mergeCls(compartmentCls, neighborhoodCls)
}
\arguments{
\item{compartmentCls}{data.frame; all predictions, including
unclassified as well, and
probablity vectors for each protein in compartment classification}

\item{neighborhoodCls}{data.frame; all predictions, including
unclassified as well, and
probablity vectors for each protein in compartment classification}
}
\value{
cls.df
}
\description{
Compartment and neighborhood classifications are merged
for the single output.
}
\examples{
{

#create mock data
com.df <- data.frame(Proteins = "TP53",
svm.pred = "N1",
S1 = as.numeric(0.02),
S2 = as.numeric(0.02),
S3 = as.numeric(0.02),
S4 = as.numeric(0.02),
N1 = as.numeric(0.72),
N2 = as.numeric(0.02),
N3 = as.numeric(0.02),
N4 = as.numeric(0.02),
C1 = as.numeric(0.02),
C2 = as.numeric(0.02),
C3 = as.numeric(0.02),
C4 = as.numeric(0.02),
C5 = as.numeric(0.02),
M1 = as.numeric(0.02),
M2 = as.numeric(0.02))

rownames(com.df) <- "TP53"

neig.df <- data.frame(Proteins = "TP53",
svm.pred.all = "Nuclear",
Secretory = as.numeric(0.01),
Nuclear = as.numeric(0.95),
Cytosol = as.numeric(0.02),
Mitochondria = as.numeric(0.02))

rownames(neig.df) <- "TP53"

cls.df <- mergeCls(com.df, neig.df)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hcc827Ctrl.R
\docType{data}
\name{hcc827Ctrl}
\alias{hcc827Ctrl}
\title{HCC827 Control Cell Line}
\format{
A data frame where 10480 protein gene-centric ids and
5 replicated subcellular fractions.
}
\usage{
hcc827Ctrl
}
\description{
Subcellular fractionated cell line.
}
\examples{
{
head(hcc827Ctrl)
}
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/replacePrediction.R
\name{replacePrediction}
\alias{replacePrediction}
\title{Replace compartment predictions to neighborhood predictions}
\usage{
replacePrediction(df, column = c("svm.pred.all", "Observation", "svm.pred"))
}
\arguments{
\item{df}{data.frame; all predictions at the compartment level and
probablity vectors for each protein}

\item{column}{character; selected column in the data frame, df}
}
\value{
replaced.df
}
\description{
Compartment level classifications are replaced with
neighborhood level assignment. It is a helper function.
}
\examples{
{

#define mock data frame
df <- data.frame(svm.pred.all = c("S1","S2","S3","S4",
"N1","N2","N3","N4",
"C1","C2","C3","C4","C5",
"M1","M2"))

df$svm.pred.all <- as.character(df$svm.pred.all)
df$Prob <- "1"

df <- replacePrediction(df, column = "svm.pred.all")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sankeyPlot.R
\name{sankeyPlot}
\alias{sankeyPlot}
\title{Sankey plot for condition-dependent protein relocalization}
\usage{
sankeyPlot(sampleCls1, sampleCls2)
}
\arguments{
\item{sampleCls1}{data.frame; merged classification,
combination of compartment and neighborhood classification.}

\item{sampleCls2}{data.frame; merged classification,
combination of compartment and neighborhood classification.}
}
\value{
label.link.df
}
\description{
Identify candidate condition-dependent relocated
proteins by comparing neighborhood classifications.
}
\examples{
{

exp.cls.df <- SubCellBarCode::hcc827GEFClass

sankeyData <- sankeyPlot(exp.cls.df, exp.cls.df)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calRowMean.R
\name{calRowMean}
\alias{calRowMean}
\title{Compute the means of replicates}
\usage{
calRowMean(d.df)
}
\arguments{
\item{d.df}{data.frame; A data frame of 10 fraction profiles
consisting of replicate A and B.}
}
\value{
r.df
}
\description{
Duplicated franctions A and B are
summarized by taking their mean for each protein.
After taking the mean, the data log2 transformed.
Further, the 5 main fractions are used to check correlation
between input datas. It is a helper function.
}
\examples{
{

r.df <- calRowMean(SubCellBarCode::hcc827Ctrl)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/svmClassifier.R
\name{svmClassification}
\alias{svmClassification}
\title{Protein subcellular localization classification}
\usage{
svmClassification(markerProteins, protein.data, markerprot.df)
}
\arguments{
\item{markerProteins}{character; robust marker proteins along
with subcellular localization that are present in the given data.}

\item{protein.data}{data.frame; fractionated proteomics data}

\item{markerprot.df}{data.frame; collection of marker proteins
along with corresponding subcellular localization}
}
\value{
all.classifications
}
\description{
Support Vector Machine classifier is trained and
used for prediction of protein subcellular localization
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

set.seed(7)
c.prots <- sample(c.prots, 500)
cls <- svmClassification(c.prots, df, markerProteins)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/markerQualityControl.R
\name{markerQualityControl}
\alias{markerQualityControl}
\title{Evaluate the quality of the marker proteins}
\usage{
markerQualityControl(coveredProteins, protein.data)
}
\arguments{
\item{coveredProteins}{character; list of marker proteins, gene
symbols, that are covered in 3365 marker proteins.}

\item{protein.data}{data.frame; fractionated proteomics data,
rownames are gene symbols associated protein.}
}
\value{
robustMarkers
}
\description{
Given the proteomics data, quality of the overlapped
marker proteins are evaluated by correlating replicates of fractions.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

r.markers <- markerQualityControl(c.prots[1:5], df)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/candidateRelocatedProteins.R
\name{candidateRelocatedProteins}
\alias{candidateRelocatedProteins}
\title{Identify candidate relocated proteins}
\usage{
candidateRelocatedProteins(
  sampleCls1,
  s1PSM,
  s1Quant,
  sampleCls2,
  s2PSM,
  s2Quant,
  annotation = FALSE,
  min.psm = 2,
  pearson.cor = 0.8
)
}
\arguments{
\item{sampleCls1}{data.frame; merged classification,
combination of compartment and neighborhood classification.}

\item{s1PSM}{data.frame; minimum PSM count table
across ten TMT channel}

\item{s1Quant}{data.frame; fractionation quantification data}

\item{sampleCls2}{data.frame; merged classification,
combination of compartment and neighborhood classification.}

\item{s2PSM}{data.frame; minimum PSM count table
across ten TMT channel}

\item{s2Quant}{data.frame; fractionation quantification data}

\item{annotation}{boolean; labeling the selected proteins}

\item{min.psm}{numeric; minimum psm, peptide spectra matching value}

\item{pearson.cor}{numeric; pearson correlation threshold}
}
\value{
candidate.df
}
\description{
Identify candidate condition-dependent
relocated proteins by comparing neighborhood classifications
with respect to protein-protein pearson correlation and minumum PSM,
peptide spectrum matching, count.
}
\examples{
{

candidate.df <- candidateRelocatedProteins(hcc827GEFClass, hcc827GefPSMCount,
hcc827GEF, hcc827GEFClass, hcc827GefPSMCount, hcc827GEF,
annotation = FALSE)


}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/applyThresholdToNeighborhood.R
\name{applyThresholdNeighborhood}
\alias{applyThresholdNeighborhood}
\title{Apply thresholds to neighborhood classification}
\usage{
applyThresholdNeighborhood(all.repA, all.repB, threshold.df)
}
\arguments{
\item{all.repA}{data.frame; all predictions and probablity vectors
for each protein in replicate A}

\item{all.repB}{data.frame; all predictions and probablity vectors
for each protein in replicate B}

\item{threshold.df}{data.frame; collection od precision and recall
values for each neighborhood}
}
\value{
n.cls.df
}
\description{
Apply thresholds for all predictions at the
neighborhood level to increase the
true positive rate and remove poor classification.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

set.seed(7)
c.prots <- sample(c.prots, 600)
cls <- svmClassification(c.prots, df, markerProteins)

test.A <- cls[[1]]$svm.test.prob.out
test.B <- cls[[2]]$svm.test.prob.out

t.n.df <- computeThresholdNeighborhood(test.A, test.B)

all.A <- cls[[1]]$all.prot.pred
all.B <- cls[[2]]$all.prot.pred

n.cls.df <- applyThresholdNeighborhood(all.A, all.B, t.n.df)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hcc827GEF.R
\docType{data}
\name{hcc827GEF}
\alias{hcc827GEF}
\title{Gefitinib treated HCC827 Cell Line}
\format{
A data frame where 10398 protein gene-centric ids and 5
replicated subcellular fractions with duplicates.
}
\usage{
hcc827GEF
}
\description{
HCC827 cell line was treated with Gefitinib which is
EGFR inhibition.
}
\examples{
{
head(hcc827GEF)
}
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coveredMarkerProtein.R
\name{calculateCoveredProtein}
\alias{calculateCoveredProtein}
\title{Evaluate marker protein coverage}
\usage{
calculateCoveredProtein(proteinIDs, markerproteins)
}
\arguments{
\item{proteinIDs}{character; gene symbol id}

\item{markerproteins}{character; 3365 proteins gene symbol ids}
}
\value{
covered.proteins
}
\description{
Given the proteomics data, number of overlapped marker
proteins is calculated.
Bar plot for each compartment is plotted.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load.data.R
\name{loadData}
\alias{loadData}
\title{Load the fractionated proteomics data}
\usage{
loadData(protein.data)
}
\arguments{
\item{protein.data}{data.frame; fractionated proteomics data where
data contains 10 columns of duplicated 5 fractionations and
rownames must be gene-centric protein names}
}
\value{
protein.data.df
}
\description{
Sampled median normalized TMT ratios are checked if
there is any "NA" valeus. If any, the corresponding
row is filtered out. Later, the data is normalized by taking log2.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl[1:20,])
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MarkerProteins.R
\docType{data}
\name{markerProteins}
\alias{markerProteins}
\title{Marker Proteins Source}
\format{
A data frame of 3365 proteins as rows and 13 columns headers.
}
\usage{
markerProteins
}
\description{
Data for the proteins whose localizations
were well characterized. It also contains color codes for each
compartment and median fractionation profiles for 5 fractions which are
Cyto., Nsol., NucI., Horg., Lorg., with replicates A and B. These
fractionation profiles will be used for the marker protein quality control.
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hcc827GEFClass.R
\docType{data}
\name{hcc827GEFClass}
\alias{hcc827GEFClass}
\title{Gefitinib treated HCC827 Cell Line Classification}
\format{
A data frame where 10398 protein gene-centric ids and corresponding
compartment and neighborhood classification alon with
classification probabilities.
}
\usage{
hcc827GEFClass
}
\description{
Gefitinib treated HCC827 cell line classification
contains both neighborhood and compartment level. The data will be
used for the relocalization analysis.
}
\examples{
{
head(hcc827GEFClass)
}
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert2symbol.R
\name{convert2symbol}
\alias{convert2symbol}
\title{Convert identifier to gene symbol}
\usage{
convert2symbol(df, id = "UNIPROT")
}
\arguments{
\item{df}{data.frame; fractionated proteomics data where
data contains 10 columns of duplicated 5 fractionations and
rownames must be identifier e.g. UNIPROT, Entrez ID}

\item{id}{caharacter; identifier id for each protein}
}
\value{
df
}
\description{
Identifier for each feature should be converted
into gene symbols unless they are not gene symbols
}
\examples{
{

df <- data.frame(Uniprot = c("A4D0S4","A8TX70","O00305","O00337"),
Organism = rep("Homo Sap.", 4))

rownames(df) <- df$Uniprot
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hcc827exon.R
\docType{data}
\name{hcc827exon}
\alias{hcc827exon}
\title{HCC827 Control Exon Cell Line}
\format{
A data frame where 500 exon-centric ensemble identifiers,
corresponding gene symbols, 5 replicated subcellular fractions
and number of unique peptides matched to associated exon.
}
\usage{
hcc827exon
}
\description{
Exon-centric sub data of hcc827 fractionated data.
}
\examples{
{
head(hcc827exon)
}
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compareCls.R
\name{compareCls}
\alias{compareCls}
\title{Compare exon and gene centric classifications}
\usage{
compareCls(geneCls, exonCls)
}
\arguments{
\item{geneCls, }{data frame gene centric classification output}

\item{exonCls, }{data frame exon centric classification output}
}
\value{
c.df
}
\description{
Comparison of the gene centric and exon
centric classification. Additionally, correlation analysis
is performed using quantification data.
}
\examples{
{

exon.cls <- data.frame(Protein = c("ENSE00000331854",
                                     "ENSE00000331855",
                                     "ENSE00000331859"),
                         NeighborhoodCls = c("Cytosol",
                                      "Cytosol",
                                      "Cytosol"),
                         CompartmentCls = c("C1","C1","C1"),
                         Secretory = c(0.1, 0.1, 0.1),
                         Nuclear = c(0.2, 0.2, 0.2),
                         Cytosol = c(0.2, 0.2, 0.2),
                         Mitochondria = c(0.2, 0.2, 0.2),
                         S1 = c(0.2, 0.2, 0.2),
                         S2 = c(0.2, 0.2, 0.2),
                         S3 = c(0.2, 0.2, 0.2),
                         S4 = c(0.2, 0.2, 0.2),
                         N1 = c(0.2, 0.2, 0.2),
                         N2 = c(0.2, 0.2, 0.2),
                         N3 = c(0.2, 0.2, 0.2),
                         N4 = c(0.2, 0.2, 0.2),
                         C1 = c(0.2, 0.2, 0.2),
                         C2 = c(0.2, 0.2, 0.2),
                         C3 = c(0.2, 0.2, 0.2),
                         C4 = c(0.2, 0.2, 0.2),
                         C5 = c(0.2, 0.2, 0.2),
                         M1 = c(0.2, 0.2, 0.2),
                         M2 = c(0.2, 0.2, 0.2),
                         GeneSymbol = c("COPB1", "COPB1", "COPB1"),
                         PeptideCount = c(2, 4, 7))

gene.cls <- data.frame(Protein = c("COPB1"),
NeighborhoodCls = c("Cytosol"),
CompartmentCls = c("C1"),
Secretory = c(0.1),
Nuclear = c(0.2),
Cytosol = c(0.2),
Mitochondria = c(0.2),
S1 = c(0.2),
S2 = c(0.2),
S3 = c(0.2),
S4 = c(0.2),
N1 = c(0.2),
N2 = c(0.2),
N3 = c(0.2),
N4 = c(0.2),
C1 = c(0.2),
C2 = c(0.2),
C3 = c(0.2),
C4 = c(0.2),
C5 = c(0.2),
M1 = c(0.2),
M2 = c(0.2))

comp.df <- compareCls(gene.cls, exon.cls)

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tSNEVisualization.R
\name{tsneVisualization}
\alias{tsneVisualization}
\title{Visualization of marker proteins by t-SNE map}
\usage{
tsneVisualization(protein.data, markerProteins, dims, theta, perplexity)
}
\arguments{
\item{protein.data}{data.frame; fractionated proteomics data}

\item{markerProteins}{character; robust marker proteins, gene
symbols, that are present in the given data and overlapped with package's
marker protein list.}

\item{dims}{integer; dimensionality}

\item{theta}{numeric; Speed/accuracy trade-off ,increase for less accuracy}

\item{perplexity}{integer; Perplexity parameter}
}
\value{
tsneMap.df
}
\description{
The marker proteins are visualized in 3D t-SNE map
to see the distributions of the marker proteins.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

set.seed(21)
tsneMap.df <- tsneVisualization(protein.data = df,
markerProteins = c.prots[1:20],
dims = 2, theta = c(0.4), perplexity = c(5))
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hcc827CtrlPSMCount.R
\docType{data}
\name{hcc827CtrlPSMCount}
\alias{hcc827CtrlPSMCount}
\title{Minimum PSM Count in HCC827Ctrl Cell Line.}
\format{
A data frame where 10480 protein gene-centric ids minimum PSM count.
}
\usage{
hcc827CtrlPSMCount
}
\description{
Minimum PSM, Peptide Sequence Match, Count table for
HCC827Ctrl Cell Line.
}
\examples{
{
head(hcc827CtrlPSMCount)
}
}
\references{
Orre et al. 2019 Cell 73, 1-17
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/probabilityThresholdNeighborhood.R
\name{computeThresholdNeighborhood}
\alias{computeThresholdNeighborhood}
\title{Probability threshold for neighborhood classification}
\usage{
computeThresholdNeighborhood(test.repA, test.repB)
}
\arguments{
\item{test.repA}{data.frame; test predictions, observation and
probablity vectors for each protein in replicate A}

\item{test.repB}{data.frame; test predictions, observation and
probablity vectors for each protein in replicate B}
}
\value{
threshold.neighborhood.df
}
\description{
Thresholds for each neighborhood are decided to get
confident predictions.
}
\examples{
{

df <- loadData(SubCellBarCode::hcc827Ctrl)

c.prots <- calculateCoveredProtein(rownames(df), markerProteins[,1])

set.seed(7)
c.prots <- sample(c.prots, 600)
cls <- svmClassification(c.prots, df, markerProteins)

test.A <- cls[[1]]$svm.test.prob.out
test.B <- cls[[2]]$svm.test.prob.out

t.n.df <- computeThresholdNeighborhood(test.A, test.B)
}
}
